// DesignView.h : interface of the CDesignView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DESIGNVIEW_H__6B0FAC89_85BD_44A0_8689_6506AB8E827A__INCLUDED_)
#define AFX_DESIGNVIEW_H__6B0FAC89_85BD_44A0_8689_6506AB8E827A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "reportx.h"


class CDesignView : public CView
{
protected: // create from serialization only
	CDesignView();
	DECLARE_DYNCREATE(CDesignView)

// Attributes
public:
	CDesignDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDesignView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDesignView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CDesignView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnFileNew();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnFileOpen();
	afx_msg void OnFileSave();
	afx_msg void OnFilePrintSetup();
	afx_msg void OnFilePrintPreview();
	afx_msg void OnFilePrint();
	afx_msg void OnEditCut();
	afx_msg void OnEditCopy();
	afx_msg void OnEditPaste();
	afx_msg void OnEditMerge();
	afx_msg void OnEditSplit();
	afx_msg void OnFormatInsertcol();
	afx_msg void OnFormatInsertrow();
	afx_msg void OnFormatDeletecol();
	afx_msg void OnInsertDeleterow();
	afx_msg void OnFormatAppendcol();
	afx_msg void OnFormatAppendrow();
	afx_msg void OnWindowFrozen();
	afx_msg void OnWindowUnfrozen();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	afx_msg void OnOnSelectChangeReportx1(long aCol1, long aRow1, long aCol2, long aRow2);
	afx_msg void OnOnInputChangeReportx1(long aCol, long aRow);
	
	DECLARE_EVENTSINK_MAP()
};

#ifndef _DEBUG  // debug version in DesignView.cpp
inline CDesignDoc* CDesignView::GetDocument()
   { return (CDesignDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DESIGNVIEW_H__6B0FAC89_85BD_44A0_8689_6506AB8E827A__INCLUDED_)
