unit Cell;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, ReportProj1_TLB,

  Grid, Butto, OleCtrls, Buttons;

type
  TCellFrm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    ListView1: TListView;
    Button1: TButton;
    Button2: TButton;
    ListView2: TListView;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    ComboBox1: TComboBox;
    Label3: TLabel;
    ComboBox2: TComboBox;
    Label4: TLabel;
    Image1: TImage;
    Button3: TButton;
    Button4: TButton;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox3: TListBox;
    ColorDialog1: TColorDialog;
    Label7: TLabel;
    ComboBox3: TComboBox;
    Label8: TLabel;
    ComboBox4: TComboBox;
    Label10: TLabel;
    Edit4: TEdit;
    Label11: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    CheckBox1: TCheckBox;
    Memo1: TMemo;
    Label13: TLabel;
    CheckBox3: TCheckBox;
    Label14: TLabel;
    Edit8: TEdit;
    Memo2: TMemo;
    Button7: TButton;
    Edit9: TEdit;
    Panel1: TPanel;
    Label9: TLabel;
    RadioButton1: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    Panel2: TPanel;
    RadioButton10: TRadioButton;
    RadioButton11: TRadioButton;
    RadioButton12: TRadioButton;
    RadioButton13: TRadioButton;
    RadioButton14: TRadioButton;
    Label15: TLabel;
    Label16: TLabel;
    ComboBox5: TComboBox;
    Label17: TLabel;
    Edit10: TEdit;
    CheckBox2: TCheckBox;
    CheckBox4: TCheckBox;
    OpenDialog1: TOpenDialog;
    Edit11: TEdit;
    Label12: TLabel;
    RadioButton15: TRadioButton;
    RadioButton16: TRadioButton;
    RadioButton17: TRadioButton;
    RadioButton18: TRadioButton;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label5: TLabel;
    Memo3: TMemo;
    ComboBox6: TComboBox;
    CheckBox5: TCheckBox;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit7: TEdit;
    Edit12: TEdit;
    Label6: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ListView2SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure CheckBox4Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

    GridFrm: TGridFrm;
  end;

implementation

{$R *.dfm}

procedure TCellFrm.Button1Click(Sender: TObject);
var
  i, j, k : Integer;
  TempInt : Integer;
begin
  case PageControl1.ActivePageIndex of
    0 :
      begin
        GridFrm.ReportX1.InvalidatePaint();
        for i := GridFrm.SelectMinx to GridFrm.SelectMaxx do
          for j := GridFrm.SelectMiny to GridFrm.SelectMaxy do
            GridFrm.ReportX1.SetCellFormat(i, j, ListView1.ItemIndex,
              Edit1.Text);
        GridFrm.ReportX1.ValidatePaint();
      end;
    1 :
      begin
        GridFrm.ReportX1.InvalidatePaint();
        for i := GridFrm.SelectMinx to GridFrm.SelectMaxx do
        begin
          for j := GridFrm.SelectMiny to GridFrm.SelectMaxy do
          begin
            case ListView2.ItemIndex of
              0 : GridFrm.ReportX1.SetTextCell(i, j);
              1 : GridFrm.ReportX1.SetDropCell(i, j, Memo2.Text);
              2 : GridFrm.ReportX1.SetButtonCell(i, j, Edit8.Text, Memo2.Text);
              3 : GridFrm.ReportX1.SetCheckCell(i, j, Edit8.Text);
              4 : GridFrm.ReportX1.SetRadioCell(i, j, Memo2.Text);
              5 : GridFrm.ReportX1.SetDateCell(i, j);
              6 : GridFrm.ReportX1.SetTimeCell(i, j);
              7 : GridFrm.ReportX1.SetLinkCell(i, j, Edit8.Text, Edit9.Text);
              8 : GridFrm.ReportX1.SetBarCodeCell(i, j,
                Combobox6.ItemIndex, False);
              9 : GridFrm.ReportX1.SetRichTextCell(i, j);
              10 : GridFrm.ReportX1.SetChartCell(i, j, Edit8.Text, Edit9.Text,
                Edit2.Text, Edit3.Text, Edit7.Text, Edit12.Text);
            end;
          end;
        end;
        GridFrm.ReportX1.ValidatePaint();
      end;
    2 :
      begin
        GridFrm.ReportX1.InvalidatePaint();
        for i := GridFrm.SelectMinx to GridFrm.SelectMaxx do
        begin
          for j := GridFrm.SelectMiny to GridFrm.SelectMaxy do
          begin
            GridFrm.ReportX1.SetCellHAlignment(i, j, Combobox1.ItemIndex);
            GridFrm.ReportX1.SetCellVAlignment(i, j, Combobox2.ItemIndex);
            if Edit11.Text = '' then
              GridFrm.ReportX1.DelCellPicture(i, j)
            else if GridFrm.ReportX1.GetCellType(i, j) <> 2 then
              GridFrm.ReportX1.AddCellPicture(i, j, Edit11.Text,
                CheckBox4.Checked);
          end;
        end;
        GridFrm.ReportX1.ValidatePaint();
      end;
    3 :
      begin
        GridFrm.ReportX1.InvalidatePaint();
        for i := GridFrm.SelectMinx to GridFrm.SelectMaxx do
        begin
          for j := GridFrm.SelectMiny to GridFrm.SelectMaxy do
          begin
            GridFrm.ReportX1.SetCellFontName(i, j,
              ListBox1.Items[ListBox1.ItemIndex]);
            GridFrm.ReportX1.SetCellFontSize(i, j,
              StrToInt(ListBox3.Items[ListBox3.ItemIndex]));
            GridFrm.ReportX1.SetCellFontStyle(i, j, 0, ListBox2.Selected[0]);
            GridFrm.ReportX1.SetCellFontStyle(i, j, 1, ListBox2.Selected[1]);
            GridFrm.ReportX1.SetCellFontStyle(i, j, 2, ListBox2.Selected[2]);
            GridFrm.ReportX1.SetCellFontStyle(i, j, 3, ListBox2.Selected[3]);
            GridFrm.ReportX1.SetCellMultiline(i, j, CheckBox3.Checked);
            GridFrm.ReportX1.SetCellFontColor(i, j, BitBtn1.Font.Color);
            GridFrm.ReportX1.SetCellBackColor(i, j, BitBtn2.Font.Color);
          end;
        end;
        GridFrm.ReportX1.ValidatePaint();
      end;
    4 :
      begin
        TempInt := 0;
        if RadioButton10.Checked = True then
          TempInt := 0
        else if RadioButton11.Checked = True then
          TempInt := 1
        else if RadioButton12.Checked = True then
          TempInt := 2
        else if RadioButton13.Checked = True then
          TempInt := 3
        else if RadioButton14.Checked = True then
          TempInt := 4;
        GridFrm.ReportX1.InvalidatePaint();
        if RadioButton1.Checked = True then
        begin
          for i := GridFrm.SelectMinx to GridFrm.SelectMaxx do
            for j := GridFrm.SelectMiny to GridFrm.SelectMaxy do
              GridFrm.ReportX1.SetCellBorder(i, j,
                1, StrToInt(Edit4.Text), TempInt);
        end
        else if RadioButton2.Checked = True then
        begin
          for i := GridFrm.SelectMinx to GridFrm.SelectMaxx do
            for j := GridFrm.SelectMiny to GridFrm.SelectMaxy do
              GridFrm.ReportX1.SetCellBorder(i, j,
                2, StrToInt(Edit4.Text), TempInt);
        end    
        else if RadioButton3.Checked = True then
        begin
          for i := GridFrm.SelectMinx to GridFrm.SelectMaxx do
            for j := GridFrm.SelectMiny to GridFrm.SelectMaxy do
              GridFrm.ReportX1.SetCellBorder(i, j,
                3, StrToInt(Edit4.Text), TempInt);
        end
        else if RadioButton4.Checked = True then
        begin
          for i := GridFrm.SelectMinx to GridFrm.SelectMaxx do
            for j := GridFrm.SelectMiny to GridFrm.SelectMaxy do
              GridFrm.ReportX1.SetCellBorder(i, j,
                4, StrToInt(Edit4.Text), TempInt);
        end
        else if RadioButton5.Checked = True then
        begin
          for i := GridFrm.SelectMinx to GridFrm.SelectMaxx do
          begin
            GridFrm.ReportX1.SetCellBorder(i, GridFrm.SelectMiny,
              2, StrToInt(Edit4.Text), TempInt);
            GridFrm.ReportX1.SetCellBorder(i, GridFrm.SelectMaxy,
              4, StrToInt(Edit4.Text), TempInt);
          end;
          for j := GridFrm.SelectMiny to GridFrm.SelectMaxy do
          begin
            GridFrm.ReportX1.SetCellBorder(GridFrm.SelectMinx, j,
              1, StrToInt(Edit4.Text), TempInt);
            GridFrm.ReportX1.SetCellBorder(GridFrm.SelectMaxx, j,
              3, StrToInt(Edit4.Text), TempInt);
          end;
        end 
        else if RadioButton6.Checked = True then
        begin
          for i := GridFrm.SelectMinx to GridFrm.SelectMaxx do
          begin
            for j := GridFrm.SelectMiny to GridFrm.SelectMaxy do
            begin
              if i <> GridFrm.SelectMinx then
                GridFrm.ReportX1.SetCellBorder(i, j,
                  1, StrToInt(Edit4.Text), TempInt);
              if j <> GridFrm.SelectMiny then
                GridFrm.ReportX1.SetCellBorder(i, j,
                  2, StrToInt(Edit4.Text), TempInt);
              if i <> GridFrm.SelectMaxx then
                GridFrm.ReportX1.SetCellBorder(i, j,
                  3, StrToInt(Edit4.Text), TempInt);
              if j <> GridFrm.SelectMaxy then
                GridFrm.ReportX1.SetCellBorder(i, j,
                  4, StrToInt(Edit4.Text), TempInt);
            end;
          end;
        end
        else if RadioButton7.Checked = True then
        begin
          for i := GridFrm.SelectMinx to GridFrm.SelectMaxx do
            for j := GridFrm.SelectMiny to GridFrm.SelectMaxy do
              GridFrm.ReportX1.SetCellBorder(i, j,
                0, StrToInt(Edit4.Text), TempInt);
        end
        else if RadioButton8.Checked = True then
        begin
          for i := GridFrm.SelectMinx to GridFrm.SelectMaxx do
            for j := GridFrm.SelectMiny to GridFrm.SelectMaxy do
              GridFrm.ReportX1.SetCellBorder(i, j, 5, 1, 0);
        end
        else if RadioButton9.Checked = True then
        begin
          for i := GridFrm.SelectMinx to GridFrm.SelectMaxx do
            for j := GridFrm.SelectMiny to GridFrm.SelectMaxy do
              GridFrm.ReportX1.SetCellBorder(i, j, 6, 1, 0);
        end;
        GridFrm.ReportX1.ValidatePaint();
      end;
    5 :
      begin
        GridFrm.ReportX1.InvalidatePaint();
        for i := GridFrm.SelectMinx to GridFrm.SelectMaxx do
        begin
          for j := GridFrm.SelectMiny to GridFrm.SelectMaxy do
          begin
            GridFrm.ReportX1.SetCellIme(i, j, Combobox3.Text);
            GridFrm.ReportX1.SetCellControl(i, j, Combobox4.ItemIndex);
            GridFrm.ReportX1.SetCellCharCase(i, j, Combobox5.ItemIndex);
            GridFrm.ReportX1.SetCellTextLength(i, j, StrToInt(Edit10.Text));
            GridFrm.ReportX1.SetCellReadOnly(i, j, CheckBox2.Checked);
            GridFrm.ReportX1.DisplayZero := CheckBox5.Checked;
          end;
        end;
        GridFrm.ReportX1.ValidatePaint();
        if RadioButton15.Checked = True then
          GridFrm.ReportX1.EnterTo := 0
        else if RadioButton16.Checked = True then
          GridFrm.ReportX1.EnterTo := 1
        else if RadioButton17.Checked = True then
          GridFrm.ReportX1.EnterTo := 2
        else if RadioButton18.Checked = True then
          GridFrm.ReportX1.EnterTo := 3;
      end;
    6 :
      begin
        GridFrm.ReportX1.InvalidatePaint();
        for i := GridFrm.SelectMinx to GridFrm.SelectMaxx do
        begin
          for j := GridFrm.SelectMiny to GridFrm.SelectMaxy do
          begin
            GridFrm.ReportX1.SetCellNextPos(i, j, StrToInt(Edit5.Text),
              StrToInt(Edit6.Text));
            GridFrm.ReportX1.SetCellPrintHide(i, j, CheckBox1.Checked);
            GridFrm.ReportX1.SetCellAppendDataLength(i, j, Memo1.Lines.Count);
            for k := 0 to Memo1.Lines.Count - 1 do
              GridFrm.ReportX1.SetCellAppendData(i, j, k, Memo1.Lines[k]);
            GridFrm.ReportX1.SetCellNote(i, j, Memo3.Text);
          end;
        end;
        GridFrm.ReportX1.ValidatePaint();
      end;
  end;
end;

procedure TCellFrm.FormCreate(Sender: TObject);
begin
  ListBox1.Items := Screen.Fonts;
  Combobox3.Items := Screen.Imes;
  Combobox3.Items.Insert(0, '');
end;

procedure TCellFrm.Button2Click(Sender: TObject);
begin
  Close();
end;

procedure TCellFrm.ListView2SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  case Item.Index of
    0 :
      begin
        Edit2.Visible := False;
        Edit3.Visible := False;
        Edit7.Visible := False;
        Edit8.Visible := False;
        Edit9.Visible := False;
        Edit12.Visible := False;
        Memo2.Visible := False;
        Button7.Visible := False;
        Combobox6.Visible := False;
        Memo2.Top := 28;  
        Edit2.Text := '';
        Edit3.Text := '';
        Edit7.Text := '';
        Edit8.Text := '';
        Edit9.Text := '';
        Edit12.Text := '';
        Memo2.Text := '';  
        Label6.Caption := '';
        Label14.Caption := '';
        Label15.Caption := '';
        Label18.Caption := '';
        Label19.Caption := '';
        Label20.Caption := '';
      end;
    1 :
      begin       
        Edit2.Visible := False;
        Edit3.Visible := False;
        Edit7.Visible := False;
        Edit8.Visible := False;
        Edit9.Visible := False;
        Edit12.Visible := False;
        Memo2.Visible := True;
        Button7.Visible := False;  
        Combobox6.Visible := False;
        Memo2.Top := 28;
        Edit2.Text := '';
        Edit3.Text := '';
        Edit7.Text := '';
        Edit8.Text := '';
        Edit9.Text := '';
        Edit12.Text := '';
        Memo2.Text := '';
        Label6.Caption := '';
        Label14.Caption := 'б';
        Label15.Caption := ''; 
        Label18.Caption := '';
        Label19.Caption := '';
        Label20.Caption := '';
        Memo2.Text := GridFrm.ReportX1.GetCellDropText(
          GridFrm.Inputx, GridFrm.Inputy);
      end;
    2 :
      begin    
        Edit2.Visible := False;
        Edit3.Visible := False;
        Edit7.Visible := False;
        Edit8.Visible := True;
        Edit9.Visible := False;
        Edit12.Visible := False;
        Memo2.Visible := True;
        Button7.Visible := True; 
        Combobox6.Visible := False;
        Memo2.Top := 52;  
        Edit2.Text := '';
        Edit3.Text := '';
        Edit7.Text := '';
        Edit8.Text := '';
        Edit9.Text := ''; 
        Edit12.Text := '';
        Memo2.Text := '';  
        Label6.Caption := '';
        Label14.Caption := 'ťǩ';
        Label15.Caption := 'ť'; 
        Label18.Caption := '';
        Label19.Caption := '';
        Label20.Caption := '';
        Edit8.Text := GridFrm.ReportX1.GetCellButtonText(
          GridFrm.Inputx, GridFrm.Inputy);
        Memo2.Text := GridFrm.ReportX1.GetCellButtonScript(
          GridFrm.Inputx, GridFrm.Inputy);
      end;
    3 :
      begin 
        Edit2.Visible := False;
        Edit3.Visible := False;
        Edit7.Visible := False;
        Edit8.Visible := True;
        Edit9.Visible := False; 
        Edit12.Visible := False;
        Memo2.Visible := False;
        Button7.Visible := False;
        Combobox6.Visible := False;
        Memo2.Top := 28;  
        Edit2.Text := '';
        Edit3.Text := '';
        Edit7.Text := '';
        Edit8.Text := '';
        Edit9.Text := ''; 
        Edit12.Text := '';
        Memo2.Text := '';  
        Label6.Caption := '';
        Label14.Caption := 'ʾǩ';
        Label15.Caption := '';  
        Label18.Caption := '';
        Label19.Caption := '';
        Label20.Caption := '';
        Edit8.Text := GridFrm.ReportX1.GetCellButtonText(
          GridFrm.Inputx, GridFrm.Inputy);
      end;
    4 :
      begin  
        Edit2.Visible := False;
        Edit3.Visible := False;
        Edit7.Visible := False;
        Edit8.Visible := False;
        Edit9.Visible := False; 
        Edit12.Visible := False;
        Memo2.Visible := True;
        Button7.Visible := False;
        Combobox6.Visible := False;
        Memo2.Top := 28;   
        Edit2.Text := '';
        Edit3.Text := '';
        Edit7.Text := '';
        Edit8.Text := '';
        Edit9.Text := '';  
        Edit12.Text := '';
        Memo2.Text := '';    
        Label6.Caption := '';
        Label14.Caption := 'ʾǩ';
        Label15.Caption := ''; 
        Label18.Caption := '';
        Label19.Caption := '';
        Label20.Caption := '';
        Memo2.Text := GridFrm.ReportX1.GetCellButtonText(
          GridFrm.Inputx, GridFrm.Inputy);
      end;
    5, 6 :
      begin 
        Edit2.Visible := False;
        Edit3.Visible := False;
        Edit7.Visible := False;
        Edit8.Visible := False;
        Edit9.Visible := False; 
        Edit12.Visible := False;
        Memo2.Visible := False;
        Button7.Visible := False;
        Combobox6.Visible := False;
        Memo2.Top := 28;  
        Edit2.Text := '';
        Edit3.Text := '';
        Edit7.Text := '';
        Edit8.Text := '';
        Edit9.Text := ''; 
        Edit12.Text := '';
        Memo2.Text := '';
        Label6.Caption := '';
        Label14.Caption := '';
        Label15.Caption := ''; 
        Label18.Caption := '';
        Label19.Caption := '';
        Label20.Caption := '';
      end;
    7 :
      begin   
        Edit2.Visible := False;
        Edit3.Visible := False;
        Edit7.Visible := False;
        Edit8.Visible := True;
        Edit9.Visible := True; 
        Edit12.Visible := False;
        Memo2.Visible := False;
        Button7.Visible := True;
        Combobox6.Visible := False;
        Memo2.Top := 28;  
        Edit2.Text := '';
        Edit3.Text := '';
        Edit7.Text := '';
        Edit8.Text := '';
        Edit9.Text := ''; 
        Edit12.Text := '';
        Memo2.Text := '';  
        Label6.Caption := '';
        Label14.Caption := 'ӱǩ';
        Label15.Caption := 'Ӳ'; 
        Label18.Caption := '';
        Label19.Caption := '';
        Label20.Caption := '';
        Edit8.Text := GridFrm.ReportX1.GetCellButtonText(
          GridFrm.Inputx, GridFrm.Inputy);
        Edit9.Text := GridFrm.ReportX1.GetCellButtonScript(
          GridFrm.Inputx, GridFrm.Inputy);
      end;
    8 :
      begin  
        Edit2.Visible := False;
        Edit3.Visible := False;
        Edit7.Visible := False;
        Edit8.Visible := False;
        Edit9.Visible := False; 
        Edit12.Visible := False;
        Memo2.Visible := False;
        Button7.Visible := False;
        Combobox6.Visible := True;
        Memo2.Top := 28;  
        Edit2.Text := '';
        Edit3.Text := '';
        Edit7.Text := '';
        Edit8.Text := '';
        Edit9.Text := '';  
        Edit12.Text := '';
        Memo2.Text := '';    
        Label6.Caption := '';
        Label14.Caption := '';
        Label15.Caption := ''; 
        Label18.Caption := '';
        Label19.Caption := '';
        Label20.Caption := '';
        Combobox6.ItemIndex := GridFrm.ReportX1.GetCellCode(
          GridFrm.Inputx, GridFrm.Inputy);
      end;
    9 :
      begin   
        Edit2.Visible := False;
        Edit3.Visible := False;
        Edit7.Visible := False;
        Edit8.Visible := False;
        Edit9.Visible := False;
        Edit12.Visible := False;
        Memo2.Visible := False;
        Button7.Visible := False;
        Combobox6.Visible := False;
        Memo2.Top := 28; 
        Edit2.Text := '';
        Edit3.Text := '';
        Edit7.Text := '';
        Edit8.Text := '';
        Edit9.Text := '';
        Edit12.Text := '';
        Memo2.Text := '';
        Label6.Caption := '';
        Label14.Caption := '';
        Label15.Caption := '';
        Label18.Caption := '';
        Label19.Caption := '';
        Label20.Caption := '';
      end;
    10 :
      begin
        Edit2.Visible := True;
        Edit3.Visible := True;
        Edit7.Visible := True;
        Edit8.Visible := True;
        Edit9.Visible := True;
        Edit12.Visible := True;
        Memo2.Visible := False;
        Button7.Visible := False;
        Combobox6.Visible := False;
        Memo2.Top := 28;
        Edit2.Text := '';
        Edit3.Text := '';
        Edit7.Text := '';
        Edit8.Text := '';
        Edit9.Text := '';
        Edit12.Text := '';
        Memo2.Text := '';
        Label6.Caption := '';
        Label14.Caption := '';
        Label15.Caption := 'ݱ';
        Label18.Caption := '';
        Label19.Caption := '';
        Label20.Caption := '';
      end;
  end;
end;

procedure TCellFrm.CheckBox4Click(Sender: TObject);
begin
  Image1.Stretch := CheckBox4.Checked;
end;

procedure TCellFrm.PageControl1Change(Sender: TObject);
var
  i : Integer;
  TempInt : Integer;
  TempInt1 : Integer;
  TempStr : WideString;
begin
  case PageControl1.ActivePageIndex of
    0 :
      begin
        GridFrm.ReportX1.GetCellFormat(GridFrm.Inputx, GridFrm.Inputy,
          TempInt, TempStr);
        ListView1.ItemIndex := TempInt;
        Edit1.Text := TempStr;
      end;
    1 :
      begin
        ListView2.ItemIndex := GridFrm.ReportX1.GetCellType(
          GridFrm.Inputx, GridFrm.Inputy);
      end;
    2 :
      begin
        Combobox1.ItemIndex := GridFrm.ReportX1.GetCellHAlignment(
          GridFrm.Inputx, GridFrm.Inputy);
        Combobox2.ItemIndex := GridFrm.ReportX1.GetCellVAlignment(
          GridFrm.Inputx, GridFrm.Inputy);
        Edit11.Text := '';
        CheckBox4.Checked := False;
        Image1.Stretch := False;
        Image1.Visible := False;
      end;
    3 :
      begin
        ListBox1.ItemIndex := ListBox1.Items.IndexOf(
          GridFrm.ReportX1.GetCellFontName(GridFrm.Inputx, GridFrm.Inputy));
        if GridFrm.ReportX1.GetCellFontStyle(
          GridFrm.Inputx, GridFrm.Inputy, 0) then
          ListBox2.Selected[0] := True
        else
          ListBox2.Selected[0] := False;
        if GridFrm.ReportX1.GetCellFontStyle(
          GridFrm.Inputx, GridFrm.Inputy, 1) then
          ListBox2.Selected[1] := True
        else
          ListBox2.Selected[1] := False;
        if GridFrm.ReportX1.GetCellFontStyle(
          GridFrm.Inputx, GridFrm.Inputy, 2) then
          ListBox2.Selected[2] := True
        else
          ListBox2.Selected[2] := False;
        if GridFrm.ReportX1.GetCellFontStyle(
          GridFrm.Inputx, GridFrm.Inputy, 3) then
          ListBox2.Selected[3] := True
        else
          ListBox2.Selected[3] := False;
        ListBox3.ItemIndex := ListBox3.Items.IndexOf(IntToStr(
          GridFrm.ReportX1.GetCellFontSize(GridFrm.Inputx, GridFrm.Inputy)));
        CheckBox3.Checked := GridFrm.ReportX1.GetCellMultiline(
          GridFrm.Inputx, GridFrm.Inputy);
        BitBtn1.Font.Color := GridFrm.ReportX1.GetCellFontColor(
          GridFrm.Inputx, GridFrm.Inputy);
        BitBtn2.Font.Color := GridFrm.ReportX1.GetCellBackColor(
          GridFrm.Inputx, GridFrm.Inputy);
      end;
    5 :
      begin
        Combobox3.ItemIndex := Combobox3.Items.IndexOf(
          GridFrm.ReportX1.GetCellIme(GridFrm.Inputx, GridFrm.Inputy));
        Combobox4.ItemIndex := GridFrm.ReportX1.GetCellControl(
          GridFrm.Inputx, GridFrm.Inputy);
        Combobox5.ItemIndex := GridFrm.ReportX1.GetCellCharCase(
          GridFrm.Inputx, GridFrm.Inputy);
        Edit10.Text := IntToStr(GridFrm.ReportX1.GetCellTextLength(
          GridFrm.Inputx, GridFrm.Inputy));
        CheckBox2.Checked := GridFrm.ReportX1.GetCellReadOnly(GridFrm.Inputx,
          GridFrm.Inputy);
        case GridFrm.ReportX1.EnterTo of
          0 : RadioButton15.Checked := True;
          1 : RadioButton16.Checked := True;
          2 : RadioButton17.Checked := True;
          3 : RadioButton18.Checked := True;
        end;
        CheckBox5.Checked := GridFrm.ReportX1.DisplayZero;
      end;
    6 :
      begin
        GridFrm.ReportX1.GetCellNextPos(GridFrm.Inputx, GridFrm.Inputy,
          TempInt, TempInt1);
        Edit5.Text := IntToStr(TempInt);
        Edit6.Text := IntToStr(TempInt1);
        CheckBox1.Checked := GridFrm.ReportX1.GetCellPrintHide(GridFrm.Inputx,
          GridFrm.Inputy);
        for i := 0 to GridFrm.ReportX1.GetCellAppendDataLength(
          GridFrm.Inputx, GridFrm.Inputy) - 1 do
          Memo1.Lines.Add(GridFrm.ReportX1.GetCellAppendData(GridFrm.Inputx,
            GridFrm.Inputy, i));
        Memo3.Text := GridFrm.ReportX1.GetCellNote(GridFrm.Inputx,
          GridFrm.Inputy);
      end;
  end;
end;

procedure TCellFrm.Button3Click(Sender: TObject);
begin
  if OpenDialog1.Execute = True then
  begin
    Edit11.Text := OpenDialog1.FileName;
    Image1.Picture.LoadFromFile(OpenDialog1.FileName);
    Image1.Visible := True;
  end;
end;

procedure TCellFrm.Button4Click(Sender: TObject);
begin
  if Edit11.Text <> '' then
  begin
    Edit11.Text := '';
    Image1.Visible := False;
  end;
end;

procedure TCellFrm.FormShow(Sender: TObject);
begin
  PageControl1.OnChange(PageControl1);
end;

procedure TCellFrm.Button7Click(Sender: TObject);
var
  ButtoFrm: TButtoFrm;
begin
  ButtoFrm := TButtoFrm.Create(Self);
  ButtoFrm.IsButton := (ListView2.ItemIndex = 2);
  ButtoFrm.ButtonText := '';
  ButtoFrm.ShowModal();
  if ButtoFrm.ButtonText <> '' then
  begin
    if (ListView2.ItemIndex = 2) then
      Memo2.Text := Memo2.Text + ButtoFrm.ButtonText + #13 + #10
    else
      Edit9.Text := ButtoFrm.ButtonText;
  end;
  ButtoFrm.Free();
end;

procedure TCellFrm.BitBtn1Click(Sender: TObject);
begin
  ColorDialog1.Color := BitBtn1.Font.Color;
  if ColorDialog1.Execute = True then
    BitBtn1.Font.Color := ColorDialog1.Color;
end;

procedure TCellFrm.BitBtn2Click(Sender: TObject);
begin
  ColorDialog1.Color := BitBtn2.Font.Color;
  if ColorDialog1.Execute = True then
    BitBtn2.Font.Color := ColorDialog1.Color;
end;

end.
