unit Grid;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ToolWin, ComCtrls, ExtCtrls, OleCtrls, ReportProj1_TLB,
  StdCtrls, ImgList,

  Main;

type
  TGridFrm = class(TForm)
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem; 
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;    
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    N16: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    N19: TMenuItem;
    N20: TMenuItem;
    N21: TMenuItem;
    N22: TMenuItem;
    N23: TMenuItem;
    N24: TMenuItem;
    N25: TMenuItem;
    N26: TMenuItem;
    N27: TMenuItem;
    N28: TMenuItem;
    PopupMenu2: TPopupMenu;
    N29: TMenuItem;
    N30: TMenuItem;
    N31: TMenuItem;
    N32: TMenuItem;
    N33: TMenuItem;
    PopupMenu3: TPopupMenu;
    N34: TMenuItem;
    N35: TMenuItem;
    N36: TMenuItem;
    N37: TMenuItem;
    N38: TMenuItem;
    ReportX1: TReportX;
    SaveDialog1: TSaveDialog;
    N39: TMenuItem;
    N40: TMenuItem;
    procedure FormCreate(Sender: TObject); 
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure ReportX1SelectChange(Sender: TObject; aCol1, aRow1, aCol2,
      aRow2: Integer);
    procedure ReportX1InputChange(Sender: TObject; aCol, aRow: Integer);
    procedure ReportX1PoleRDown(Sender: TObject; aIndex, aOrientation,
      aScreenX, aScreenY: Integer);
    procedure ReportX1CellRDown(Sender: TObject; aCol, aRow, aScreenX,
      aScreenY: Integer);
    procedure ReportX1SelectObject(Sender: TObject; ObjectType: Integer;
      const ObjectName: WideString);
    procedure ReportX1Error(Sender: TObject; const aMessage: WideString);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure N12Click(Sender: TObject);
    procedure N13Click(Sender: TObject);
    procedure N15Click(Sender: TObject);
    procedure N16Click(Sender: TObject);
    procedure N17Click(Sender: TObject);
    procedure N18Click(Sender: TObject);
    procedure N20Click(Sender: TObject);
    procedure N21Click(Sender: TObject);
    procedure N22Click(Sender: TObject);
    procedure N23Click(Sender: TObject);
    procedure N25Click(Sender: TObject);
    procedure N26Click(Sender: TObject);
    procedure N27Click(Sender: TObject);
    procedure N28Click(Sender: TObject);
    procedure N29Click(Sender: TObject);
    procedure N30Click(Sender: TObject);
    procedure N31Click(Sender: TObject);
    procedure N33Click(Sender: TObject);
    procedure N34Click(Sender: TObject);
    procedure N35Click(Sender: TObject);
    procedure N36Click(Sender: TObject);
    procedure N38Click(Sender: TObject);
    procedure N39Click(Sender: TObject);
    procedure N40Click(Sender: TObject);
  private
    { Private declarations }
    
    procedure CMDialogKey(var Message : TCMDialogKey);
      message CM_DIALOGKEY;
  public
    { Public declarations }

    Main : TMainFrm;
    Living : Boolean;
    FileName : string;
    SelectMinx : Integer;
    SelectMiny : Integer;
    SelectMaxx : Integer;
    SelectMaxy : Integer;
    Inputx : Integer;
    Inputy : Integer;   

    function SetSaveReport() : Boolean;
  end;

implementation

{$R *.dfm}

function TGridFrm.SetSaveReport() : Boolean;
begin
  Result := False;
  if FileName = 'δ' then
  begin
    if SaveDialog1.Execute = True then
    begin
      FileName := SaveDialog1.FileName;
      Self.Caption := SaveDialog1.FileName;
    end
    else begin
      Exit;
    end;
  end;
  try
    ReportX1.SaveReport(FileName);
    Result := True;
  except
  end;
end;

procedure TGridFrm.CMDialogKey(var Message: TCMDialogKey);
begin
  if (Message.CharCode < 37) or (Message.CharCode > 40) then
    Inherited;
end;

procedure TGridFrm.FormCreate(Sender: TObject);
begin
  Living := True;
  FileName := 'δ';
  SelectMinx := 0;
  SelectMiny := 0;
  SelectMaxx := 0;
  SelectMaxy := 0;
  Inputx := 0;
  Inputy := 0;
end;       

procedure TGridFrm.FormShow(Sender: TObject);
begin
  ReportX1.SetFocus();
end;

procedure TGridFrm.FormClose(Sender: TObject; var Action: TCloseAction);
var
  n : Integer;
begin
  if ReportX1.Saved = True then
  begin
    Action := caFree;
    Living := False;
  end
  else begin
    n := MessageBox(Application.Handle, PChar('"' + FileName +
      '" ļ޸ģǷ񱣴޸ĵݣ'),
      'ʾ', MB_YESNOCANCEL + MB_ICONQUESTION);
    if n = IDYES then
    begin
      if SetSaveReport() = True then
      begin
        Action := caFree;
        Living := False;
      end
      else begin
        Action := caNone;
      end;
    end
    else if n = IDNO then
    begin
      Action := caFree;
      Living := False;
    end
    else begin
      Action := caNone;
    end;
  end;
end;  

procedure TGridFrm.FormActivate(Sender: TObject);
begin
  if Main <> nil then
  begin
    Main.StatusBar1.Panels[0].Text := 'ѡΧ  (' + IntToStr(SelectMinx) + ',' +
      IntToStr(SelectMiny) + ')' + '-' + '(' + IntToStr(SelectMaxx) + ',' +
      IntToStr(SelectMaxy) + ')';
    Main.StatusBar1.Panels[1].Text := '뷶Χ ' + IntToStr(Inputx) + ',' +
      IntToStr(Inputy);

    if (Inputx > 0) and (Inputy > 0) then
    begin
      Main.Combobox1.OnChange := nil;
      Main.Combobox1.ItemIndex := Main.Combobox1.Items.IndexOf(
        ReportX1.GetCellFontName(Inputx, Inputy));
      Main.Combobox1.OnChange := Main.Combobox1Change;
      Main.Combobox2.OnChange := nil;
      Main.Combobox2.ItemIndex := Main.Combobox2.Items.IndexOf(
        IntToStr(ReportX1.GetCellFontSize(Inputx, Inputy)));
      Main.Combobox2.OnChange := Main.Combobox2Change;
      Main.ToolButton27.Down := ReportX1.GetCellFontStyle(Inputx, Inputy, 0);
      Main.ToolButton28.Down := ReportX1.GetCellFontStyle(Inputx, Inputy, 1);
      Main.ToolButton29.Down := ReportX1.GetCellFontStyle(Inputx, Inputy, 2);
      Main.ToolButton30.Down := ReportX1.GetCellFontStyle(Inputx, Inputy, 3);
      Main.ToolButton33.Down := ReportX1.GetCellMultiline(Inputx, Inputy);
      Main.ToolButton40.Down := ReportX1.GetCellReadOnly(Inputx, Inputy);
    end;

    Main.N55.Checked := ReportX1.ExecuteScript;
    Main.N74.Checked := ReportX1.MoveChart;
    Main.N75.Checked := ReportX1.UpdateChart;
    Main.N90.Checked := ReportX1.SeparatorLine;
    Main.N103.Checked := ReportX1.GridLine;
    Main.N105.Checked := ReportX1.CellReadOnly;
    Main.N106.Checked := ReportX1.PoleReadOnly;
  end;
end;

procedure TGridFrm.ReportX1SelectChange(Sender: TObject; aCol1, aRow1,
  aCol2, aRow2: Integer);
begin
  SelectMinx := aCol1;
  SelectMiny := aRow1;
  SelectMaxx := aCol2;
  SelectMaxy := aRow2;
  Main.StatusBar1.Panels[0].Text := 'ѡΧ  (' + IntToStr(SelectMinx) + ',' +
    IntToStr(SelectMiny) + ')' + '-' + '(' + IntToStr(SelectMaxx) + ',' +
    IntToStr(SelectMaxy) + ')';
end;

procedure TGridFrm.ReportX1InputChange(Sender: TObject; aCol,
  aRow: Integer);
begin
  Inputx := aCol;
  Inputy := aRow;
  Main.StatusBar1.Panels[1].Text := '뷶Χ ' + IntToStr(Inputx) + ',' +
    IntToStr(Inputy);

  if (Inputx > 0) and (Inputy > 0) then
  begin
    Main.Combobox1.OnChange := nil;
    Main.Combobox1.ItemIndex := Main.Combobox1.Items.IndexOf(
      ReportX1.GetCellFontName(Inputx, Inputy));
    Main.Combobox1.OnChange := Main.Combobox1Change;
    Main.Combobox2.OnChange := nil;
    Main.Combobox2.ItemIndex := Main.Combobox2.Items.IndexOf(
      IntToStr(ReportX1.GetCellFontSize(Inputx, Inputy)));
    Main.Combobox2.OnChange := Main.Combobox2Change;
    Main.ToolButton27.Down := ReportX1.GetCellFontStyle(Inputx, Inputy, 0);
    Main.ToolButton28.Down := ReportX1.GetCellFontStyle(Inputx, Inputy, 1);
    Main.ToolButton29.Down := ReportX1.GetCellFontStyle(Inputx, Inputy, 2);
    Main.ToolButton30.Down := ReportX1.GetCellFontStyle(Inputx, Inputy, 3);
    Main.ToolButton33.Down := ReportX1.GetCellMultiline(Inputx, Inputy);
    Main.ToolButton40.Down := ReportX1.GetCellReadOnly(Inputx, Inputy);
    Main.Edit1.Text := ReportX1.GetCellExpression(Inputx, Inputy);
  end;
end;

procedure TGridFrm.ReportX1PoleRDown(Sender: TObject; aIndex, aOrientation,
  aScreenX, aScreenY: Integer);
begin
  if aOrientation = 0 then
    PopupMenu2.Popup(aScreenX, aScreenY)
  else
    PopupMenu3.Popup(aScreenX, aScreenY);
end;

procedure TGridFrm.ReportX1CellRDown(Sender: TObject; aCol, aRow, aScreenX,
  aScreenY: Integer);
begin
  PopupMenu1.Popup(aScreenX, aScreenY);
end;      

procedure TGridFrm.ReportX1SelectObject(Sender: TObject;
  ObjectType: Integer; const ObjectName: WideString);
begin
  {if (ObjectType = 1) and (ObjectName <> '') then
  begin
    if (SerieFrm <> nil) and (SerieFrm.ChartName <> ObjectName) then
      SerieFrm.PageControl1.OnChange(SerieFrm.PageControl1);
  end; }
end;      

procedure TGridFrm.ReportX1Error(Sender: TObject;
  const aMessage: WideString);
begin
  Application.MessageBox(Pchar(string(aMessage)), 'ʾ');
end;

procedure TGridFrm.N1Click(Sender: TObject);
begin
  if (SelectMinx <> 0) and (SelectMiny <> 0) and (SelectMaxx <> 0) and
    (SelectMaxy <> 0) then
  begin
    ReportX1.CutCell(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy);
  end
  else if ReportX1.GetSelectChartName() <> '' then
  begin
    ReportX1.CutObject(ReportX1.GetSelectChartName());
  end;
end;

procedure TGridFrm.N2Click(Sender: TObject);
begin
  if (SelectMinx <> 0) and (SelectMiny <> 0) and (SelectMaxx <> 0) and
    (SelectMaxy <> 0) then
  begin
    ReportX1.CopyCell(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy);
  end
  else if ReportX1.GetSelectChartName() <> '' then
  begin
    ReportX1.CopyObject(ReportX1.GetSelectChartName());
  end;
end;

procedure TGridFrm.N3Click(Sender: TObject);
begin
  if (Inputx <> 0) and (Inputy <> 0) then
  begin
    ReportX1.ExecuteScript := False;
    ReportX1.Paste(Inputx, Inputy, True);
    ReportX1.ExecuteScript := True;
  end;
end;     

procedure TGridFrm.N6Click(Sender: TObject);
begin
  ReportX1.MergeCell(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy);
end;

procedure TGridFrm.N7Click(Sender: TObject);
begin
  ReportX1.SplitCell(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy);
end;   

procedure TGridFrm.N10Click(Sender: TObject);
begin
  ReportX1.Fill(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy, 0, 0);
end;

procedure TGridFrm.N11Click(Sender: TObject);
begin
  ReportX1.Fill(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy, 1, 0);
end;

procedure TGridFrm.N12Click(Sender: TObject);
begin
  ReportX1.Fill(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy, 2, 0);
end;

procedure TGridFrm.N13Click(Sender: TObject);
begin
  ReportX1.Fill(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy, 3, 0);
end;

procedure TGridFrm.N15Click(Sender: TObject);
begin
  ReportX1.Fill(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy, 0, 1);
end;

procedure TGridFrm.N16Click(Sender: TObject);
begin
  ReportX1.Fill(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy, 1, 1);
end;

procedure TGridFrm.N17Click(Sender: TObject);
begin
  ReportX1.Fill(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy, 2, 1);
end;

procedure TGridFrm.N18Click(Sender: TObject);
begin
  ReportX1.Fill(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy, 3, 1);
end;

procedure TGridFrm.N20Click(Sender: TObject);
begin
  ReportX1.Fill(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy, 0, 2);
end;

procedure TGridFrm.N21Click(Sender: TObject);
begin
  ReportX1.Fill(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy, 1, 2);
end;

procedure TGridFrm.N22Click(Sender: TObject);
begin
  ReportX1.Fill(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy, 2, 2);
end;

procedure TGridFrm.N23Click(Sender: TObject);
begin
  ReportX1.Fill(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy, 3, 2);
end;

procedure TGridFrm.N25Click(Sender: TObject);
begin
  ReportX1.Fill(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy, 0, 3);
end;

procedure TGridFrm.N26Click(Sender: TObject);
begin
  ReportX1.Fill(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy, 1, 3);
end;

procedure TGridFrm.N27Click(Sender: TObject);
begin
  ReportX1.Fill(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy, 2, 3);
end;

procedure TGridFrm.N28Click(Sender: TObject);
begin
  ReportX1.Fill(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy, 3, 3);
end;

procedure TGridFrm.N29Click(Sender: TObject);
begin
  ReportX1.InsertCol(Inputx, 1);
end;

procedure TGridFrm.N30Click(Sender: TObject);
begin
  ReportX1.DeleteCol(SelectMinx, SelectMaxx - SelectMinx + 1);
end;

procedure TGridFrm.N31Click(Sender: TObject);
begin
  ReportX1.AppendCol(1);
end;    

procedure TGridFrm.N33Click(Sender: TObject);
var
  i : Integer;
begin
  if (SelectMinx > 0) and (SelectMaxx > 0) then
  begin
    ReportX1.EndEditCell(True);
    for i := SelectMinx to SelectMaxx do
      ReportX1.SetColWidth(i, ReportX1.GetColBestWidth(i));
  end;
end;

procedure TGridFrm.N34Click(Sender: TObject);
begin
  ReportX1.InsertRow(Inputy, 1);
end;  

procedure TGridFrm.N35Click(Sender: TObject);
begin
  ReportX1.DeleteRow(SelectMiny, SelectMaxy - SelectMiny + 1);
end;

procedure TGridFrm.N36Click(Sender: TObject);
begin
  ReportX1.AppendRow(1);
end;

procedure TGridFrm.N38Click(Sender: TObject);
var
  i : Integer;
begin
  if (SelectMiny > 0) and (SelectMaxy > 0) then
  begin
    ReportX1.EndEditCell(True);
    for i := SelectMiny to SelectMaxy do
      ReportX1.SetRowHeight(i, ReportX1.GetRowBestHeight(i));
  end;
end;

procedure TGridFrm.N39Click(Sender: TObject);
begin
  ReportX1.ClearData(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy);
end;

procedure TGridFrm.N40Click(Sender: TObject);
begin
  ReportX1.ClearCell(SelectMinx, SelectMiny, SelectMaxx, SelectMaxy);
end;

end.
