unit Serie;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls,

  Grid, Para, Data;

type
  TSerieFrm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    RadioButton10: TRadioButton;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label3: TLabel;
    Edit2: TEdit;
    Label4: TLabel;
    Edit3: TEdit;
    Button2: TButton;
    TabSheet3: TTabSheet;
    Label5: TLabel;
    Edit4: TEdit;
    Label6: TLabel;
    Edit5: TEdit;
    CheckBox1: TCheckBox;
    ComboBox1: TComboBox;
    Button6: TButton;
    Edit6: TEdit;
    Button8: TButton;
    Panel2: TPanel;
    RadioButton11: TRadioButton;
    RadioButton12: TRadioButton;
    RadioButton13: TRadioButton;
    RadioButton14: TRadioButton;
    RadioButton15: TRadioButton;
    RadioButton16: TRadioButton;
    RadioButton17: TRadioButton;
    RadioButton18: TRadioButton;
    RadioButton19: TRadioButton;
    RadioButton20: TRadioButton;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Label10: TLabel;
    Edit11: TEdit;
    Label11: TLabel;
    Edit12: TEdit;
    Label12: TLabel;
    Edit13: TEdit;
    Label13: TLabel;
    Edit14: TEdit;
    Button12: TButton;
    Button7: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button12Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

    GridFrm: TGridFrm;
    ChartName : string;
  end;

var
  SerieFrm: TSerieFrm;

implementation

uses
  Value;

{$R *.dfm}

procedure TSerieFrm.Button1Click(Sender: TObject);
var
  ParaFrm: TParaFrm;
begin
  ParaFrm := TParaFrm.Create(Self);
  if RadioButton1.Checked = True then
    ParaFrm.SeriesType := 0
  else if RadioButton2.Checked = True then
    ParaFrm.SeriesType := 1
  else if RadioButton3.Checked = True then
    ParaFrm.SeriesType := 2
  else if RadioButton4.Checked = True then
    ParaFrm.SeriesType := 3
  else if RadioButton5.Checked = True then
    ParaFrm.SeriesType := 4
  else if RadioButton6.Checked = True then
    ParaFrm.SeriesType := 5
  else if RadioButton7.Checked = True then
    ParaFrm.SeriesType := 6
  else if RadioButton8.Checked = True then
    ParaFrm.SeriesType := 7
  else if RadioButton9.Checked = True then
    ParaFrm.SeriesType := 8
  else if RadioButton10.Checked = True then
    ParaFrm.SeriesType := 9;
  ParaFrm.ShowModal();
  Edit1.Text := ParaFrm.ParaStr;
end;

procedure TSerieFrm.Button3Click(Sender: TObject);
var
  TempInt : Integer;
begin
  TempInt := 0;
  if RadioButton1.Checked = True then
    TempInt := 1
  else if RadioButton2.Checked = True then
    TempInt := 2
  else if RadioButton3.Checked = True then
    TempInt := 3
  else if RadioButton4.Checked = True then
    TempInt := 4
  else if RadioButton5.Checked = True then
    TempInt := 5
  else if RadioButton6.Checked = True then
    TempInt := 6
  else if RadioButton7.Checked = True then
    TempInt := 7
  else if RadioButton8.Checked = True then
    TempInt := 8
  else if RadioButton9.Checked = True then
    TempInt := 9
  else if RadioButton10.Checked = True then
    TempInt := 10;
  GridFrm.ReportX1.AddChartSeries(ChartName, TempInt, Edit6.Text + ',' + Edit1.Text,
    Edit2.Text, Edit3.Text);
end;

procedure TSerieFrm.Button2Click(Sender: TObject);
var
  DataFrm: TDataFrm;
begin
  DataFrm := TDataFrm.Create(Self);
  DataFrm.CountEdit := Edit6;
  DataFrm.DataEdit := Edit2;
  DataFrm.ShowModal();
end;

procedure TSerieFrm.Button6Click(Sender: TObject);
begin
  ValueFrm := TValueFrm.Create(Self);
  ValueFrm.GridFrm := GridFrm;
  ValueFrm.DataEdit := Edit3;
  ValueFrm.Show();
end;

procedure TSerieFrm.Button7Click(Sender: TObject);
begin
  GridFrm.ReportX1.SetChartRange(ChartName, StrToInt(Edit4.Text),
    StrToInt(Edit5.Text));
  GridFrm.ReportX1.SetChartReadOnly(ChartName, CheckBox1.Checked);
  GridFrm.ReportX1.ChangeObjectChart(ChartName, -1, -1, Edit12.Text,
    Edit13.Text, Edit14.Text);
end;

procedure TSerieFrm.Button8Click(Sender: TObject);
begin
  if GridFrm.ReportX1.GetSelectChartName <> ChartName then
    GridFrm.ReportX1.SetSelectObjectChart(ChartName);
  Close();
end;

procedure TSerieFrm.Button5Click(Sender: TObject);
begin
  if Combobox1.ItemIndex >= 0 then
  begin
    GridFrm.ReportX1.DelChartSeries(ChartName, Combobox1.ItemIndex + 1);
    PageControl1.OnChange(PageControl1);
    Combobox1.ItemIndex := 0;
  end;
end;

procedure TSerieFrm.ComboBox1Change(Sender: TObject);
var
  TempInt1 : Integer;
  TempInt2 : Integer;
  TempStr1 : WideString;
  TempStr2 : WideString;
  TempStr3 : WideString;
begin
  GridFrm.ReportX1.GetChartSeries(ChartName, Combobox1.ItemIndex + 1,
    TempInt1, TempStr1, TempStr2, TempStr3);
  case TempInt1 of
    1 : RadioButton11.Checked := True;
    2 : RadioButton12.Checked := True;
    3 : RadioButton13.Checked := True;
    4 : RadioButton14.Checked := True;
    5 : RadioButton15.Checked := True;
    6 : RadioButton16.Checked := True;
    7 : RadioButton17.Checked := True;
    8 : RadioButton18.Checked := True;
    9 : RadioButton19.Checked := True;
    10 : RadioButton20.Checked := True;
  end;
  TempInt2 := Pos(',', TempStr1);
  if TempInt2 = 0 then
  begin
    Edit7.Text := '';
    Edit10.Text := TempStr1;
  end
  else begin
    Edit7.Text := Copy(TempStr1, TempInt2 + 1, Length(TempStr1) - TempInt2);
    Edit10.Text := Copy(TempStr1, 1, TempInt2 - 1);
  end;
  Edit8.Text := TempStr2;
  Edit9.Text := TempStr3;
end;

procedure TSerieFrm.PageControl1Change(Sender: TObject);
var
  i : Integer;
  TempInt1 : Integer;
  TempInt2 : Integer;
  TempStr1 : WideString;
  TempStr2 : WideString;
  TempStr3 : WideString;
begin
  case PageControl1.ActivePageIndex of
    0 :
      begin
        GridFrm.ReportX1.GetChartRange(ChartName, TempInt1, TempInt2);
        Edit4.Text := IntToStr(TempInt1);
        Edit5.Text := IntToStr(TempInt2);
        CheckBox1.Checked := GridFrm.ReportX1.GetChartReadOnly(ChartName);
        Edit11.Text := ChartName;
        GridFrm.ReportX1.GetObjectChart(ChartName, TempStr1, TempStr2, TempStr3);
        Edit12.Text := TempStr1;
        Edit13.Text := TempStr2;
        Edit14.Text := TempStr3;
        Button3.Visible := False;
        Button4.Visible := False;
        Button5.Visible := False;
        Button7.Visible := True;
        Button12.Visible := True;
      end;
    1 :
      begin
        Button3.Visible := True;
        Button4.Visible := False;
        Button5.Visible := False;
        Button7.Visible := False;
        Button12.Visible := False;
      end;
    2 :
      begin
        Combobox1.Items.Clear;
        for i := 0 to GridFrm.ReportX1.GetChartSeriesCount(ChartName) - 1 do
          Combobox1.Items.Add(IntToStr(i + 1));
        Button3.Visible := False;
        Button4.Visible := True;
        Button5.Visible := True;
        Button7.Visible := False;
        Button12.Visible := False;
      end;
  end;
end;

procedure TSerieFrm.Button4Click(Sender: TObject);
var
  TempInt : Integer;
begin
  TempInt := 0;
  if RadioButton11.Checked = True then
    TempInt := 1
  else if RadioButton12.Checked = True then
    TempInt := 2
  else if RadioButton13.Checked = True then
    TempInt := 3
  else if RadioButton14.Checked = True then
    TempInt := 4
  else if RadioButton15.Checked = True then
    TempInt := 5
  else if RadioButton16.Checked = True then
    TempInt := 6
  else if RadioButton17.Checked = True then
    TempInt := 7
  else if RadioButton18.Checked = True then
    TempInt := 8
  else if RadioButton19.Checked = True then
    TempInt := 9
  else if RadioButton20.Checked = True then
    TempInt := 10;
  if Combobox1.ItemIndex >= 0 then
    GridFrm.ReportX1.ChangeChartSeires(ChartName, Combobox1.ItemIndex + 1,
    TempInt, Edit10.Text + ',' + Edit7.Text, Edit8.Text, Edit9.Text);
end;

procedure TSerieFrm.Button9Click(Sender: TObject);
var
  ParaFrm: TParaFrm;
begin
  ParaFrm := TParaFrm.Create(Self);
  if RadioButton11.Checked = True then
    ParaFrm.SeriesType := 0
  else if RadioButton12.Checked = True then
    ParaFrm.SeriesType := 1
  else if RadioButton13.Checked = True then
    ParaFrm.SeriesType := 2
  else if RadioButton14.Checked = True then
    ParaFrm.SeriesType := 3
  else if RadioButton15.Checked = True then
    ParaFrm.SeriesType := 4
  else if RadioButton16.Checked = True then
    ParaFrm.SeriesType := 5
  else if RadioButton17.Checked = True then
    ParaFrm.SeriesType := 6
  else if RadioButton18.Checked = True then
    ParaFrm.SeriesType := 7
  else if RadioButton19.Checked = True then
    ParaFrm.SeriesType := 8
  else if RadioButton20.Checked = True then
    ParaFrm.SeriesType := 9;
  ParaFrm.ShowModal();
  Edit7.Text := ParaFrm.ParaStr;
  ParaFrm.Free();
end;

procedure TSerieFrm.Button10Click(Sender: TObject);
var
  DataFrm: TDataFrm;
begin
  DataFrm := TDataFrm.Create(Self);
  DataFrm.CountEdit := Edit10;
  DataFrm.DataEdit := Edit8;
  DataFrm.ShowModal();
  DataFrm.Free();
end;

procedure TSerieFrm.Button11Click(Sender: TObject);
begin
  ValueFrm := TValueFrm.Create(Self);
  ValueFrm.GridFrm := GridFrm;
  ValueFrm.DataEdit := Edit9;
  ValueFrm.ShowModal();
  ValueFrm.Free();
end;

procedure TSerieFrm.FormShow(Sender: TObject);
begin
  PageControl1.OnChange(PageControl1);
end;

procedure TSerieFrm.Button12Click(Sender: TObject);
begin
  GridFrm.ReportX1.ClearChartSeries(ChartName);
end;

end.
