unit Excel;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,

  Grid;

type
  TExcelFrm = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Edit4: TEdit;
    Label5: TLabel;
    Edit5: TEdit;
    Button2: TButton;
    Button3: TButton;
    SaveDialog1: TSaveDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

    GridFrm: TGridFrm;
    OpenOrSave : Boolean;
  end;

implementation

{$R *.dfm}

procedure TExcelFrm.Button1Click(Sender: TObject);
begin
  if OpenOrSave = True then
  begin
    if OpenDialog1.Execute = True then
      Edit1.Text := OpenDialog1.FileName;
  end
  else begin
    if SaveDialog1.Execute = True then
      Edit1.Text := SaveDialog1.FileName;
  end;
end;

procedure TExcelFrm.Button2Click(Sender: TObject);
begin
  if OpenOrSave = True then
    GridFrm.ReportX1.ImportExcelOle(Edit1.Text, StrToInt(Edit2.Text),
      StrToInt(Edit3.Text), StrToInt(Edit4.Text), StrToInt(Edit5.Text), True)
  else
    GridFrm.ReportX1.ExportExcelOle(Edit1.Text, StrToInt(Edit2.Text),
      StrToInt(Edit3.Text), StrToInt(Edit4.Text), StrToInt(Edit5.Text), 'Sheet1', True);
  Close();
end;

procedure TExcelFrm.Button3Click(Sender: TObject);
begin
  Close();
end;

end.
