unit Field;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,

  Grid, ComCtrls;

type
  TFieldFrm = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    ComboBox1: TComboBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ListView1: TListView;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

    GridFrm : TGridFrm;
  end;

implementation

{$R *.dfm}

procedure TFieldFrm.Button1Click(Sender: TObject);
begin
  GridFrm.ReportX1.AddFieldCell(Trim(Edit1.Text),
    Trim(Edit2.Text), Combobox1.ItemIndex);
end;

procedure TFieldFrm.Button2Click(Sender: TObject);
begin
  Close();
end;

procedure TFieldFrm.Button3Click(Sender: TObject);
var
  i : Integer;
  TempInt : Integer;
  TempStr : WideString;
  TempStrs : TStringList;
  TempItem : TListItem;
begin
  ListView1.Items.Clear();
  TempStrs := TStringList.Create;
  TempStrs.Text := GridFrm.ReportX1.GetAllFieldCell();
  for i := 0 to TempStrs.Count - 1 do
  begin
    TempItem := ListView1.Items.Add();
    TempItem.Caption := TempStrs[i];
    GridFrm.ReportX1.GetFieldCell(TempStrs[i], TempStr, TempInt);
    TempItem.SubItems.Add(TempStr);
    TempItem.SubItems.Add(IntToStr(TempInt));
  end;
end;

procedure TFieldFrm.Button4Click(Sender: TObject);
var
  i : Integer;
begin
  for i := ListView1.Items.Count - 1 downto 0 do
  begin
    if ListView1.Items[i].Selected = True then
    begin
      GridFrm.ReportX1.DelFieldCell(ListView1.Items[i].Caption);
      ListView1.Items[i].Delete;
    end;
  end;
end;

end.
