unit Sort;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,

  Grid;

type
  TSortFrm = class(TForm)
    Panel1: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Panel2: TPanel;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    Label2: TLabel;
    ComboBox2: TComboBox;
    Panel3: TPanel;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    ComboBox3: TComboBox;
    Panel4: TPanel;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    Label3: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure FormShow(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

    GridFrm: TGridFrm;
  end;

implementation

{$R *.dfm}

procedure TSortFrm.FormShow(Sender: TObject);
var
  i : Integer;
begin
  if RadioButton1.Checked = True then
  begin
    Combobox1.Items.Clear();
    Combobox2.Items.Clear();
    Combobox3.Items.Clear();
    for i := GridFrm.SelectMinx to GridFrm.SelectMaxx do
    begin
      Combobox1.Items.Add(IntToStr(i));
      Combobox2.Items.Add(IntToStr(i));
      Combobox3.Items.Add(IntToStr(i));
    end;
    Combobox1.ItemIndex := -1;
    Combobox2.ItemIndex := -1;
    Combobox3.ItemIndex := -1;
  end
  else begin
    Combobox1.Items.Clear();
    Combobox2.Items.Clear();
    Combobox3.Items.Clear();
    for i := GridFrm.SelectMiny to GridFrm.SelectMaxy do
    begin
      Combobox1.Items.Add(IntToStr(i));
      Combobox2.Items.Add(IntToStr(i));
      Combobox3.Items.Add(IntToStr(i));
    end;
    Combobox1.ItemIndex := -1;
    Combobox2.ItemIndex := -1;
    Combobox3.ItemIndex := -1;
  end;
  RadioButton3.Checked := True;
  RadioButton5.Checked := True;
  RadioButton7.Checked := True;
end;

procedure TSortFrm.RadioButton1Click(Sender: TObject);
var
  i : Integer;
begin
  if RadioButton1.Checked = True then
  begin
    Combobox1.Items.Clear();
    Combobox2.Items.Clear();
    Combobox3.Items.Clear();
    for i := GridFrm.SelectMinx to GridFrm.SelectMaxx do
    begin
      Combobox1.Items.Add(IntToStr(i));
      Combobox2.Items.Add(IntToStr(i));
      Combobox3.Items.Add(IntToStr(i));
    end;
    Combobox1.ItemIndex := -1;
    Combobox2.ItemIndex := -1;
    Combobox3.ItemIndex := -1;
  end
  else begin
    Combobox1.Items.Clear();
    Combobox2.Items.Clear();
    Combobox3.Items.Clear();
    for i := GridFrm.SelectMiny to GridFrm.SelectMaxy do
    begin
      Combobox1.Items.Add(IntToStr(i));
      Combobox2.Items.Add(IntToStr(i));
      Combobox3.Items.Add(IntToStr(i));
    end;
    Combobox1.ItemIndex := -1;
    Combobox2.ItemIndex := -1;
    Combobox3.ItemIndex := -1;
  end;
  RadioButton3.Checked := True;
  RadioButton5.Checked := True;
  RadioButton7.Checked := True;
end;

procedure TSortFrm.RadioButton2Click(Sender: TObject);
var
  i : Integer;
begin
  if RadioButton1.Checked = True then
  begin
    Combobox1.Items.Clear();
    Combobox2.Items.Clear();
    Combobox3.Items.Clear();
    for i := GridFrm.SelectMinx to GridFrm.SelectMaxx do
    begin
      Combobox1.Items.Add(IntToStr(i));
      Combobox2.Items.Add(IntToStr(i));
      Combobox3.Items.Add(IntToStr(i));
    end;
    Combobox1.ItemIndex := -1;
    Combobox2.ItemIndex := -1;
    Combobox3.ItemIndex := -1;
  end
  else begin
    Combobox1.Items.Clear();
    Combobox2.Items.Clear();
    Combobox3.Items.Clear();
    for i := GridFrm.SelectMiny to GridFrm.SelectMaxy do
    begin
      Combobox1.Items.Add(IntToStr(i));
      Combobox2.Items.Add(IntToStr(i));
      Combobox3.Items.Add(IntToStr(i));
    end;
    Combobox1.ItemIndex := -1;
    Combobox2.ItemIndex := -1;
    Combobox3.ItemIndex := -1;
  end;
  RadioButton3.Checked := True;
  RadioButton5.Checked := True;
  RadioButton7.Checked := True;
end;

procedure TSortFrm.Button1Click(Sender: TObject);
begin
  if RadioButton1.Checked = True then
  begin
    if Combobox3.ItemIndex > -1 then
      GridFrm.ReportX1.SortCol(StrToInt(Combobox3.Text), GridFrm.SelectMinx,
        GridFrm.SelectMiny, GridFrm.SelectMaxx, GridFrm.SelectMaxy,
        RadioButton7.Checked);
    if Combobox2.ItemIndex > -1 then
      GridFrm.ReportX1.SortCol(StrToInt(Combobox2.Text), GridFrm.SelectMinx,
        GridFrm.SelectMiny, GridFrm.SelectMaxx, GridFrm.SelectMaxy,
        RadioButton5.Checked);
    if Combobox1.ItemIndex > -1 then
      GridFrm.ReportX1.SortCol(StrToInt(Combobox1.Text), GridFrm.SelectMinx,
        GridFrm.SelectMiny, GridFrm.SelectMaxx, GridFrm.SelectMaxy,
        RadioButton3.Checked);
  end
  else begin
    if Combobox3.ItemIndex > -1 then
      GridFrm.ReportX1.SortRow(StrToInt(Combobox3.Text), GridFrm.SelectMinx,
        GridFrm.SelectMiny, GridFrm.SelectMaxx, GridFrm.SelectMaxy,
        RadioButton7.Checked);
    if Combobox2.ItemIndex > -1 then
      GridFrm.ReportX1.SortRow(StrToInt(Combobox2.Text), GridFrm.SelectMinx,
        GridFrm.SelectMiny, GridFrm.SelectMaxx, GridFrm.SelectMaxy,
        RadioButton5.Checked);
    if Combobox1.ItemIndex > -1 then
      GridFrm.ReportX1.SortRow(StrToInt(Combobox1.Text), GridFrm.SelectMinx,
        GridFrm.SelectMiny, GridFrm.SelectMaxx, GridFrm.SelectMaxy,
        RadioButton3.Checked);
  end;
  Close();
end;

procedure TSortFrm.Button2Click(Sender: TObject);
begin
  Close();
end;

end.
