unit Text;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,

  Grid;

type
  TTextFrm = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label2: TLabel;
    Edit2: TEdit;
    Button2: TButton;
    Button3: TButton;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

    GridFrm: TGridFrm;
    OpenOrSave : Boolean;
  end;

implementation

{$R *.dfm}

procedure TTextFrm.Button2Click(Sender: TObject);
var
  TempStr : string;
  TempString : TStringStream;
  TempMemory : TMemoryStream;
begin
  if RadioButton1.Checked = True then
    TempStr := #9
  else if RadioButton2.Checked = True then
    TempStr := ','
  else if RadioButton2.Checked = True then
    TempStr := ';'
  else if RadioButton2.Checked = True then
    TempStr := ' '
  else
    TempStr := Edit2.Text;
  if OpenOrSave = True then
  begin
    TempMemory := TMemoryStream.Create();
    TempMemory.LoadFromFile(Edit1.Text);
    TempMemory.Position := 0;
    TempString := TStringStream.Create('');
    TempMemory.SaveToStream(TempString);
    TempString.Position := 0;
    GridFrm.ReportX1.ImportText(1, 1, TempString.DataString, TempStr);
  end
  else begin
    TempString := TStringStream.Create(
      GridFrm.ReportX1.ExportText(1, 1, GridFrm.ReportX1.ColCount,
      GridFrm.ReportX1.RowCount, TempStr));
    TempString.Position := 0;
    TempMemory := TMemoryStream.Create();
    TempMemory.LoadFromStream(TempString);
    TempMemory.Position := 0;
    TempMemory.SaveToFile(Edit1.Text);
  end;
  Close();
end;

procedure TTextFrm.Button1Click(Sender: TObject);
begin
  if OpenOrSave = True then
  begin
    if OpenDialog1.Execute = True then
      Edit1.Text := OpenDialog1.FileName;
  end
  else begin
    if SaveDialog1.Execute = True then
      Edit1.Text := SaveDialog1.FileName;
  end;
end;

procedure TTextFrm.Button3Click(Sender: TObject);
begin
  Close();
end;

end.
