unit Value;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,

  Grid, OleCtrls, ReportProj1_TLB;

type
  TValueFrm = class(TForm)
    ListBox1: TListBox;
    ListBox2: TListBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Label1: TLabel;
    Button6: TButton;
    ReportX1: TReportX;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

    GridFrm : TGridFrm;
    DataEdit: TEdit;
  end;

var
  ValueFrm: TValueFrm;

implementation

{$R *.dfm}

procedure TValueFrm.Button1Click(Sender: TObject);
var
  i, j : Integer;
  SelectMinx : Integer;
  SelectMiny : Integer;
  SelectMaxx : Integer;
  SelectMaxy : Integer;
begin
  ReportX1.GetSelectCell(SelectMinx, SelectMiny,
    SelectMaxx, SelectMaxy);
  for i := SelectMinx to SelectMaxx do
    for j := SelectMiny to SelectMaxy do
      ListBox1.Items.Add(IntToStr(i) + ',' + IntToStr(j));
end;

procedure TValueFrm.Button2Click(Sender: TObject);
var
  i, j : Integer; 
  SelectMinx : Integer;
  SelectMiny : Integer;
  SelectMaxx : Integer;
  SelectMaxy : Integer;
begin
  ReportX1.GetSelectCell(SelectMinx, SelectMiny,
    SelectMaxx, SelectMaxy);
  for i := SelectMinx to SelectMaxx do
    for j := SelectMiny to SelectMaxy do
      ListBox2.Items.Add(IntToStr(i) + ',' + IntToStr(j));
end;

procedure TValueFrm.Button3Click(Sender: TObject);
begin
  ListBox1.Items.Clear();
end;

procedure TValueFrm.Button4Click(Sender: TObject);
begin
  ListBox2.Items.Clear();
end;

procedure TValueFrm.Button5Click(Sender: TObject);
var
  i : Integer;
begin
  if ListBox1.Items.Count <> ListBox2.Items.Count then
  begin
    Application.MessageBox('XYݸ', 'ʾ');
    Exit;
  end;
  DataEdit.Text := '';
  for i := 0 to ListBox1.Items.Count - 1 do
  begin
    DataEdit.Text := DataEdit.Text + ListBox1.Items[i] + ',';
    if i = ListBox1.Items.Count - 1 then
      DataEdit.Text := DataEdit.Text + ListBox2.Items[i]
    else
      DataEdit.Text := DataEdit.Text + ListBox2.Items[i] + ',';
  end;
  Close();
end;

procedure TValueFrm.Button6Click(Sender: TObject);
begin
  Close();
end;

procedure TValueFrm.FormShow(Sender: TObject);
var
  i : Integer;
  TempStrs : TStringList;
begin
  ReportX1.OpenString(GridFrm.ReportX1.SaveString(False), False);
  TempStrs := TStringList.Create;
  TempStrs.Text := ReportX1.GetAllChartName();
  for i := 0 to TempStrs.Count - 1 do
    ReportX1.DelObjectChart(TempStrs[i]);
  ReportX1.CellReadOnly := True;
  ReportX1.PoleReadOnly := True;
end;

end.
