using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Designer
{
    public partial class Main : Form
    {
        public Main()
        {
            InitializeComponent();

            System.Drawing.Text.InstalledFontCollection fonts =
                new System.Drawing.Text.InstalledFontCollection();
            foreach (FontFamily family in fonts.Families)
            {
                toolStripComboBox1.Items.Add(family.Name);
            }
        }

        private void ĵ½ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Grid grid = new Grid();
            grid.Activated += new System.EventHandler(this.Grid_Activated);
            grid.MdiParent = this;
            grid.Show();
            grid.WindowState = FormWindowState.Maximized;
            grid.fileName = "δ";
            grid.Text = grid.fileName;
        }

        private void ڱĵ½ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                New new_ = new New();
                new_.ColCount = 10;
                new_.RowCount = 50;
                if (new_.ShowDialog() == DialogResult.OK)
                {
                    ((Grid)this.ActiveMdiChild).reportX.NewReport(new_.ColCount, new_.RowCount);
                    ((Grid)this.ActiveMdiChild).fileName = "δ";
                    ((Grid)this.ActiveMdiChild).Text = ((Grid)this.ActiveMdiChild).fileName;
                }
            }
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            openFileDialog1.FileName = "";
            openFileDialog1.Filter = "ReportXļ|*.rpxe|ļ|*.*";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                Grid grid = new Grid();
                grid.Activated += new System.EventHandler(this.Grid_Activated);
                grid.MdiParent = this;
                grid.Show();
                grid.WindowState = FormWindowState.Maximized;

                grid.reportX.OpenReport(openFileDialog1.FileName);
                grid.fileName = openFileDialog1.FileName;
                grid.Text = ((Grid)this.ActiveMdiChild).fileName;
            }
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                saveFileDialog1.FileName = "";
                saveFileDialog1.Filter = "ReportXļ|*.rpxe|ļ|*.*";
                saveFileDialog1.DefaultExt = "rpxe";
                if (((Grid)this.ActiveMdiChild).fileName != "δ" ||
                saveFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    if (((Grid)this.ActiveMdiChild).fileName == "δ")
                        ((Grid)this.ActiveMdiChild).fileName = saveFileDialog1.FileName;
                    ((Grid)this.ActiveMdiChild).reportX.SaveReport(((Grid)this.ActiveMdiChild).fileName);
                    ((Grid)this.ActiveMdiChild).Text = ((Grid)this.ActiveMdiChild).fileName;
                }
            }
        }

        private void ΪToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                saveFileDialog1.FileName = "";
                saveFileDialog1.Filter = "ReportXļ|*.rpxe|ļ|*.*";
                saveFileDialog1.DefaultExt = "rpxe";
                if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    ((Grid)this.ActiveMdiChild).reportX.SaveReport(saveFileDialog1.FileName);
                    ((Grid)this.ActiveMdiChild).fileName = saveFileDialog1.FileName;
                    ((Grid)this.ActiveMdiChild).Text = ((Grid)this.ActiveMdiChild).fileName;
                }
            }
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < this.MdiChildren.Length; i++)
            {
                if (this.MdiChildren[i] != null)
                {
                    saveFileDialog1.FileName = "";
                    saveFileDialog1.Filter = "ReportXļ|*.rpxe|ļ|*.*";
                    saveFileDialog1.DefaultExt = "rpxe";
                    if (((Grid)this.ActiveMdiChild).fileName != "δ" ||
                        saveFileDialog1.ShowDialog() == DialogResult.OK)
                    {
                        if (((Grid)this.ActiveMdiChild).fileName == "δ")
                            ((Grid)this.ActiveMdiChild).fileName = saveFileDialog1.FileName;
                        ((Grid)this.MdiChildren[i]).reportX.SaveReport(((Grid)this.ActiveMdiChild).fileName);
                        ((Grid)this.ActiveMdiChild).Text = ((Grid)this.ActiveMdiChild).fileName;
                    }
                }
            }
        }

        private void رToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).Close();
            }
        }

        private void رToolStripMenuItem_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < this.MdiChildren.Length; i++)
            {
                if (this.MdiChildren[i] != null)
                {
                    ((Grid)this.MdiChildren[i]).Close();
                }
            }
        }

        private void ӡToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.PrintSetup();
            }
        }

        private void ӡԤToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.PrintPreview();
            }
        }

        private void ӡToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.PrintSheet(true);
            }
        }

        private void ʾToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void ˳ToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < this.MdiChildren.Length; i++)
            {
                if (this.MdiChildren[i] != null)
                {
                    ((Grid)this.MdiChildren[i]).Close();
                }
            }
            this.Close();
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.CutCell(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy);
            }
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.CopyCell(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy);
            }
        }

        private void ճToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.Paste(((Grid)this.ActiveMdiChild).inputx,
                    ((Grid)this.ActiveMdiChild).inputy, true);
            }
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.ClearCell(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy);
            }
        }

        private void ϲToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.MergeCell(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy);
            }
        }

        private void ָToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.SplitCell(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy);
            }
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void 滻ToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void תToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void ظToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.Fill(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy, 0, 0);
            }
        }

        private void ظToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.Fill(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy, 1, 0);
            }

        }

        private void ظToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.Fill(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy, 2, 0);
            }
        }

        private void ظToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.Fill(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy, 3, 0);
            }
        }

        private void ȲToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.Fill(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy, 0, 1);
            }
        }

        private void ϵȲToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.Fill(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy, 1, 1);
            }
        }

        private void ҵȲToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.Fill(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy, 2, 1);
            }
        }

        private void µȲToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.Fill(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy, 3, 1);
            }
        }

        private void ȱToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.Fill(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy, 0, 2);
            }
        }

        private void ϵȱToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.Fill(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy, 1, 2);
            }
        }

        private void ҵȱToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.Fill(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy, 2, 2);
            }
        }

        private void µȱToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.Fill(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy, 3, 2);
            }
        }

        private void ʽToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.Fill(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy, 0, 3);
            }
        }

        private void ϹʽToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.Fill(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy, 1, 3);
            }
        }

        private void ҹʽToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.Fill(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy, 2, 3);
            }
        }

        private void ¹ʽToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.Fill(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMiny, ((Grid)this.ActiveMdiChild).selectMaxx,
                    ((Grid)this.ActiveMdiChild).selectMaxy, 3, 3);
            }
        }

        private void ԪToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                if (((Grid)this.ActiveMdiChild).selectMinx > 0 &&
                    ((Grid)this.ActiveMdiChild).selectMiny > 0 &&
                    ((Grid)this.ActiveMdiChild).selectMaxx > 0 &&
                    ((Grid)this.ActiveMdiChild).selectMaxy > 0)
                {
                    Cell cell = new Cell();
                    cell.grid = (Grid)this.ActiveMdiChild;
                    cell.ShowDialog();                    
                }
            }
        }

        private void пToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                for ( int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    ((Grid)this.ActiveMdiChild).reportX.SetColWidth(i, 
                        ((Grid)this.ActiveMdiChild).reportX.GetColBestWidth(i));
                }
            }
        }

        private void иToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                for (int i = ((Grid)this.ActiveMdiChild).selectMiny; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxy; i++)
                {
                    ((Grid)this.ActiveMdiChild).reportX.SetRowHeight(i,
                        ((Grid)this.ActiveMdiChild).reportX.GetRowBestHeight(i));
                }
            }
        }

        private void пToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                if (((Grid)this.ActiveMdiChild).selectMinx > 0 &&
                    ((Grid)this.ActiveMdiChild).selectMaxx > 0)
                {
                    Range range = new Range("п", ((Grid)this.ActiveMdiChild).reportX.GetColWidth(
                        ((Grid)this.ActiveMdiChild).inputx));
                    range.Text = "п";
                    if (range.ShowDialog() == DialogResult.OK)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                        for (int i = ((Grid)this.ActiveMdiChild).selectMinx;
                            i <= ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                            ((Grid)this.ActiveMdiChild).reportX.SetColWidth(i, range.RangeInt);
                        ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
                    }
                }
            }
        }

        private void иToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                if (((Grid)this.ActiveMdiChild).selectMiny > 0 &&
                    ((Grid)this.ActiveMdiChild).selectMaxy > 0)
                {
                    Range range = new Range("и", ((Grid)this.ActiveMdiChild).reportX.GetRowHeight(
                        ((Grid)this.ActiveMdiChild).inputy));
                    range.Text = "ип";
                    if (range.ShowDialog() == DialogResult.OK)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                        for (int i = ((Grid)this.ActiveMdiChild).selectMiny;
                            i <= ((Grid)this.ActiveMdiChild).selectMaxy; i++)
                            ((Grid)this.ActiveMdiChild).reportX.SetRowHeight(i, range.RangeInt);
                        ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
                    }
                }
            }
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InsertCol(((Grid)this.ActiveMdiChild).inputx, 1);
            }
        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InsertRow(((Grid)this.ActiveMdiChild).inputy, 1);
            }
        }

        private void ɾToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.DeleteCol(((Grid)this.ActiveMdiChild).selectMinx,
                    ((Grid)this.ActiveMdiChild).selectMaxx - ((Grid)this.ActiveMdiChild).selectMinx + 1);
            }
        }

        private void ɾToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.DeleteRow(((Grid)this.ActiveMdiChild).selectMiny,
                    ((Grid)this.ActiveMdiChild).selectMaxy - ((Grid)this.ActiveMdiChild).selectMiny + 1);
            }
        }

        private void ׷ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.AppendCol(1);
            }
        }

        private void ׷ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.AppendRow(1);
            }
        }

        private void ùʽToolStripMenuItem_Click(object sender, EventArgs e)
        {
             if (this.ActiveMdiChild != null)
            {
                if (((Grid)this.ActiveMdiChild).selectMinx > 0 &&
                   ((Grid)this.ActiveMdiChild).selectMiny > 0 &&
                   ((Grid)this.ActiveMdiChild).selectMaxx > 0 &&
                   ((Grid)this.ActiveMdiChild).selectMaxy > 0)
                {
                    Expre expre = new Expre();
                    expre.grid = ((Grid)this.ActiveMdiChild);
                    expre.ExpressMinx = ((Grid)this.ActiveMdiChild).selectMinx;
                    expre.ExpressMiny = ((Grid)this.ActiveMdiChild).selectMiny;
                    expre.ExpressMaxx = ((Grid)this.ActiveMdiChild).selectMaxx;
                    expre.ExpressMaxy = ((Grid)this.ActiveMdiChild).selectMaxy;
                    expre.ExpressStr = ((Grid)this.ActiveMdiChild).reportX.GetCellExpression(
                        ((Grid)this.ActiveMdiChild).inputx,
                        ((Grid)this.ActiveMdiChild).inputy);
                    expre.ExpressStart = "";
                    expre.ExpressEnd = "";
                    expre.ExpressCursor = -1;
                    if ((((Grid)this.ActiveMdiChild).selectMinx ==
                        ((Grid)this.ActiveMdiChild).selectMaxx) &&
                        (((Grid)this.ActiveMdiChild).selectMiny ==
                        ((Grid)this.ActiveMdiChild).selectMaxy))
                        expre.Text = expre.Text + "(" + System.Convert.ToString(
                            ((Grid)this.ActiveMdiChild).selectMinx) +
                          ", " + System.Convert.ToString(((Grid)this.ActiveMdiChild).selectMiny) + ")";
                    else
                        expre.Text = expre.Text + "(" + System.Convert.ToString(
                            ((Grid)this.ActiveMdiChild).selectMinx) +
                          ", " + System.Convert.ToString(((Grid)this.ActiveMdiChild).selectMiny) + ", " +
                          System.Convert.ToString(((Grid)this.ActiveMdiChild).selectMaxx) + ", " +
                          System.Convert.ToString(((Grid)this.ActiveMdiChild).selectMaxy) + ")";
                    if (expre.ShowDialog() == DialogResult.OK)
                    {
                        for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                            ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                        {
                            for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                                ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                            {
                                ((Grid)this.ActiveMdiChild).reportX.SetCellExpression(i, j, expre.ExpressStr);
                            }
                        }
                    }
                }
            }
        }

        private void ȫToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.ExplainAllExpresion(0);
            }
        }

        private void ȫToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.ExplainAllExpresion(1);
            }
        }

        private void ñToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                Alias alias = new Alias();
                alias.grid = (Grid)this.ActiveMdiChild;
                alias.ShowDialog();
            }
        }

        private void ᴰToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                int tempInt1 = 0;
                int tempInt2 = 0;
                ((Grid)this.ActiveMdiChild).reportX.GetFrozenCol(out tempInt1, out tempInt2);
                if (((Grid)this.ActiveMdiChild).inputx == 1)
                    ((Grid)this.ActiveMdiChild).reportX.SetFrozenCol(0, 0);
                else if (tempInt1 > 0)
                    ((Grid)this.ActiveMdiChild).reportX.SetFrozenCol(tempInt1,
                        ((Grid)this.ActiveMdiChild).inputx - 1);
                else
                    ((Grid)this.ActiveMdiChild).reportX.SetFrozenCol(
                        ((Grid)this.ActiveMdiChild).reportX.LeftCol, ((Grid)this.ActiveMdiChild).inputx - 1);
                ((Grid)this.ActiveMdiChild).reportX.LeftCol = ((Grid)this.ActiveMdiChild).inputx;
                ((Grid)this.ActiveMdiChild).reportX.GetFrozenRow(out tempInt1, out tempInt2);
                if (((Grid)this.ActiveMdiChild).inputy == 1)
                    ((Grid)this.ActiveMdiChild).reportX.SetFrozenRow(0, 0);
                else if (tempInt1 > 0)
                    ((Grid)this.ActiveMdiChild).reportX.SetFrozenRow(tempInt1,
                        ((Grid)this.ActiveMdiChild).inputy - 1);
                else
                    ((Grid)this.ActiveMdiChild).reportX.SetFrozenRow(
                        ((Grid)this.ActiveMdiChild).reportX.TopRow, ((Grid)this.ActiveMdiChild).inputy - 1);
                ((Grid)this.ActiveMdiChild).reportX.TopRow = ((Grid)this.ActiveMdiChild).inputy;
            }
        }

        private void ȡToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.SetFrozenCol(0, 0);
                ((Grid)this.ActiveMdiChild).reportX.SetFrozenRow(0, 0);
            }
        }

        private void зҳToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.SetColPageBreak(
                    ((Grid)this.ActiveMdiChild).inputx, true);
            }
        }

        private void зҳToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.SetRowPageBreak(
                    ((Grid)this.ActiveMdiChild).inputy, true);
            }
        }

        private void ɾзҳToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.SetColPageBreak(
                    ((Grid)this.ActiveMdiChild).inputx, false);
            }
        }

        private void ɾзҳToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.SetRowPageBreak(
                    ((Grid)this.ActiveMdiChild).inputy, false);
            }
        }

        private void ʾҳToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.SeparatorLine =
                    !((Grid)this.ActiveMdiChild).reportX.SeparatorLine;
                ʾҳToolStripMenuItem.Checked =
                    ((Grid)this.ActiveMdiChild).reportX.SeparatorLine;
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void ʾդToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.GridLine =
                    !((Grid)this.ActiveMdiChild).reportX.GridLine;
                ʾҳToolStripMenuItem.Checked =
                    ((Grid)this.ActiveMdiChild).reportX.GridLine;
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void ļToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void ToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void Grid_Activated(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ʾҳToolStripMenuItem.Checked = ((Grid)this.ActiveMdiChild).reportX.SeparatorLine;
                ʾդToolStripMenuItem.Checked = ((Grid)this.ActiveMdiChild).reportX.GridLine;
            }
        }

        private void Main_Load(object sender, EventArgs e)
        {
            Grid grid = new Grid();
            grid.Activated += new System.EventHandler(this.Grid_Activated);
            grid.MdiParent = this;
            grid.Show();
            grid.WindowState = FormWindowState.Maximized;
            grid.fileName = "δ";
            grid.Text = grid.fileName;
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            ĵ½ToolStripMenuItem_Click(sender, e);
        }

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            ToolStripMenuItem_Click(sender, e);
        }

        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            ToolStripMenuItem_Click(sender, e);
        }

        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            ӡToolStripMenuItem_Click(sender, e);
        }

        private void toolStripButton5_Click(object sender, EventArgs e)
        {
            ӡԤToolStripMenuItem_Click(sender, e);
        }

        private void toolStripButton6_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.PrintSheet(false);
            }
        }

        private void toolStripButton7_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                Pole pole = new Pole(((Grid)this.ActiveMdiChild).reportX.PoleWidth, 
                    ((Grid)this.ActiveMdiChild).reportX.PoleHeight);
                if (pole.ShowDialog() == DialogResult.OK)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                        ((Grid)this.ActiveMdiChild).reportX.PoleWidth = pole.PoleWidth;
                        ((Grid)this.ActiveMdiChild).reportX.PoleHeight = pole.PoleHeight;
                        ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
                    }
            }
        }

        private void toolStripButton13_Click(object sender, EventArgs e)
        {
            пToolStripMenuItem_Click(sender, e);
        }

        private void toolStripButton14_Click(object sender, EventArgs e)
        {
            иToolStripMenuItem_Click(sender, e);
        }

        private void toolStripButton15_Click(object sender, EventArgs e)
        {
            ToolStripMenuItem_Click(sender, e);
        }

        private void toolStripButton16_Click(object sender, EventArgs e)
        {
            ToolStripMenuItem_Click(sender, e);
        }

        private void toolStripButton17_Click(object sender, EventArgs e)
        {
            ɾToolStripMenuItem_Click(sender, e);
        }

        private void toolStripButton18_Click(object sender, EventArgs e)
        {
            ɾToolStripMenuItem_Click(sender, e);
        }

        private void toolStripButton19_Click(object sender, EventArgs e)
        {
            ׷ToolStripMenuItem_Click(sender, e);
        }

        private void toolStripButton20_Click(object sender, EventArgs e)
        {
            ׷ToolStripMenuItem_Click(sender, e);
        }

        private void toolStripButton8_Click(object sender, EventArgs e)
        {
            ToolStripMenuItem_Click(sender, e);
        }

        private void toolStripButton9_Click(object sender, EventArgs e)
        {
            ToolStripMenuItem_Click(sender, e);
        }

        private void toolStripButton10_Click(object sender, EventArgs e)
        {
            ճToolStripMenuItem_Click(sender, e);
        }

        private void toolStripButton11_Click(object sender, EventArgs e)
        {
            ϲToolStripMenuItem_Click(sender, e);
        }

        private void toolStripButton12_Click(object sender, EventArgs e)
        {
            ָToolStripMenuItem_Click(sender, e);
        }

        private void toolStripButton21_Click(object sender, EventArgs e)
        {
            ᴰToolStripMenuItem_Click(sender, e);
        }

        private void toolStripButton22_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                bool tempBool = ((Grid)this.ActiveMdiChild).reportX.GetCellFontStyle(
                    ((Grid)this.ActiveMdiChild).inputx, ((Grid)this.ActiveMdiChild).inputy, 0);
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellFontStyle(i, j, 0, !tempBool);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
                toolStripButton22.Checked = !tempBool;
            }
        }

        private void toolStripButton23_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                bool tempBool = ((Grid)this.ActiveMdiChild).reportX.GetCellFontStyle(
                    ((Grid)this.ActiveMdiChild).inputx, ((Grid)this.ActiveMdiChild).inputy, 1);
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellFontStyle(i, j, 1, !tempBool);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
                toolStripButton23.Checked = !tempBool;
            }
        }

        private void toolStripButton24_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                bool tempBool = ((Grid)this.ActiveMdiChild).reportX.GetCellFontStyle(
                    ((Grid)this.ActiveMdiChild).inputx, ((Grid)this.ActiveMdiChild).inputy, 2);
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellFontStyle(i, j, 2, !tempBool);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
                toolStripButton24.Checked = !tempBool;
            }
        }

        private void toolStripButton25_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                bool tempBool = ((Grid)this.ActiveMdiChild).reportX.GetCellFontStyle(
                    ((Grid)this.ActiveMdiChild).inputx, ((Grid)this.ActiveMdiChild).inputy, 3);
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellFontStyle(i, j, 3, !tempBool);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
                toolStripButton25.Checked = !tempBool;
            }
        }

        private void toolStripButton26_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null && colorDialog1.ShowDialog() == DialogResult.OK)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellFontColor(i, j, colorDialog1.Color);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void toolStripButton27_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null && colorDialog1.ShowDialog() == DialogResult.OK)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellBackColor(i, j, colorDialog1.Color);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void toolStripButton28_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                bool tempBool = ((Grid)this.ActiveMdiChild).reportX.GetCellMultiline(
                    ((Grid)this.ActiveMdiChild).inputx, ((Grid)this.ActiveMdiChild).inputy);
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellMultiline(i, j, !tempBool);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
                toolStripButton28.Checked = !tempBool;
            }
        }

        private void toolStripButton29_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellHAlignment(i, j, 
                            ReportX.THAlignment.LeftJustify);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void toolStripButton30_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellHAlignment(i, j,
                            ReportX.THAlignment.HCenter);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void toolStripButton31_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellHAlignment(i, j,
                            ReportX.THAlignment.RightJustify);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void toolStripButton32_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellVAlignment(i, j,
                            ReportX.TVAlignment.TopJustify);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void toolStripButton33_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellVAlignment(i, j,
                            ReportX.TVAlignment.VCenter);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void toolStripButton34_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellVAlignment(i, j,
                            ReportX.TVAlignment.BottomJustify);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void toolStripButton35_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                bool tempBool = ((Grid)this.ActiveMdiChild).reportX.GetCellReadOnly(
                    ((Grid)this.ActiveMdiChild).inputx, ((Grid)this.ActiveMdiChild).inputy);
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellReadOnly(i, j, !tempBool);
                    }
                }
                toolStripButton35.Checked = !tempBool;
            }
        }

        private void toolStripButton36_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellBorder(i, j, 0, 1, 0);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void toolStripButton37_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    ((Grid)this.ActiveMdiChild).reportX.SetCellBorder(i,
                        ((Grid)this.ActiveMdiChild).selectMiny, 2, 1, 0);
                    ((Grid)this.ActiveMdiChild).reportX.SetCellBorder(i,
                        ((Grid)this.ActiveMdiChild).selectMaxy, 4, 1, 0);
                }
                for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                     ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                {
                    ((Grid)this.ActiveMdiChild).reportX.SetCellBorder(
                        ((Grid)this.ActiveMdiChild).selectMinx, j, 1, 1, 0);
                    ((Grid)this.ActiveMdiChild).reportX.SetCellBorder(
                        ((Grid)this.ActiveMdiChild).selectMaxx, j, 3, 1, 0);
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void toolStripButton38_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellBorder(i, j, 0, 0, 0);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void toolStripButton39_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        if (i != ((Grid)this.ActiveMdiChild).selectMinx)
                            ((Grid)this.ActiveMdiChild).reportX.SetCellBorder(i, j, 1, 1, 0);
                        if (j != ((Grid)this.ActiveMdiChild).selectMiny)
                            ((Grid)this.ActiveMdiChild).reportX.SetCellBorder(i, j, 2, 1, 0);
                        if (i != ((Grid)this.ActiveMdiChild).selectMaxx)
                            ((Grid)this.ActiveMdiChild).reportX.SetCellBorder(i, j, 3, 1, 0);
                        if (j != ((Grid)this.ActiveMdiChild).selectMaxy)
                            ((Grid)this.ActiveMdiChild).reportX.SetCellBorder(i, j, 4, 1, 0);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void toolStripButton40_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellBorder(i, j, 1, 1, 0);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void toolStripButton41_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellBorder(i, j, 2, 1, 0);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void toolStripButton42_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellBorder(i, j, 3, 1, 0);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void toolStripButton43_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellBorder(i, j, 4, 1, 0);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void toolStripButton44_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    ((Grid)this.ActiveMdiChild).reportX.SetCellBorder(i,
                        ((Grid)this.ActiveMdiChild).selectMiny, 2, 2, 0);
                    ((Grid)this.ActiveMdiChild).reportX.SetCellBorder(i,
                        ((Grid)this.ActiveMdiChild).selectMaxy, 4, 2, 0);
                }
                for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                     ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                {
                    ((Grid)this.ActiveMdiChild).reportX.SetCellBorder(
                        ((Grid)this.ActiveMdiChild).selectMinx, j, 1, 2, 0);
                    ((Grid)this.ActiveMdiChild).reportX.SetCellBorder(
                        ((Grid)this.ActiveMdiChild).selectMaxx, j, 3, 2, 0);
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void toolStripButton45_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                openFileDialog1.FileName = "";
                openFileDialog1.Filter = "BMPͼƬ|*.bmp|ļ|*.*";
                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                    for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                        ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                    {
                        for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                            ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                        {
                            ((Grid)this.ActiveMdiChild).reportX.AddCellPicture(i, j,
                                openFileDialog1.FileName, true);
                        }
                    }
                    ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
                }
            }
        }

        private void toolStripButton46_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.AddCellPicture(i, j, "", false);
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void toolStripButton47_Click(object sender, EventArgs e)
        {
            ùʽToolStripMenuItem_Click(sender, e);
        }

        private void toolStripButton48_Click(object sender, EventArgs e)
        {
            ȫToolStripMenuItem_Click(sender, e);
        }

        private void toolStripComboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellFontName(i, j,
                            toolStripComboBox1.Items[toolStripComboBox1.SelectedIndex].ToString());
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        private void toolStripComboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                ((Grid)this.ActiveMdiChild).reportX.InvalidatePaint();
                for (int i = ((Grid)this.ActiveMdiChild).selectMinx; i <=
                    ((Grid)this.ActiveMdiChild).selectMaxx; i++)
                {
                    for (int j = ((Grid)this.ActiveMdiChild).selectMiny; j <=
                        ((Grid)this.ActiveMdiChild).selectMaxy; j++)
                    {
                        ((Grid)this.ActiveMdiChild).reportX.SetCellFontSize(i, j,
                            int.Parse(
                            toolStripComboBox2.Items[toolStripComboBox2.SelectedIndex].ToString()));
                    }
                }
                ((Grid)this.ActiveMdiChild).reportX.ValidatePaint();
            }
        }

        public void SetMainSelectStatus(string selectRange)
        {
            tsl_select.Text = selectRange;
        }

        public void SetMainInputStatus(string inputCell, bool styleBold, bool styleItalic,
            bool styleUnderline, bool styleStrikeout, bool cellMultiline, bool cellReadonly,
            bool alignLeft, bool alignHCenter, bool alignRight, bool alignTop, bool alignVCenter, 
            bool alignBottom, string fontName, int fontSize)
        {
            tsl_input.Text = inputCell;
            toolStripButton22.Checked = styleBold;
            toolStripButton23.Checked = styleItalic;
            toolStripButton24.Checked = styleUnderline;
            toolStripButton25.Checked = styleStrikeout;
            toolStripButton28.Checked = cellMultiline;
            toolStripButton29.Checked = alignLeft;
            toolStripButton30.Checked = alignHCenter;
            toolStripButton31.Checked = alignRight;
            toolStripButton32.Checked = alignTop;
            toolStripButton33.Checked = alignVCenter;
            toolStripButton34.Checked = alignBottom;
            toolStripButton35.Checked = cellReadonly;
            this.toolStripComboBox1.SelectedIndexChanged -= 
                new System.EventHandler(this.toolStripComboBox1_SelectedIndexChanged);
            toolStripComboBox1.SelectedIndex = toolStripComboBox1.Items.IndexOf(fontName);
            this.toolStripComboBox1.SelectedIndexChanged +=
                new System.EventHandler(this.toolStripComboBox1_SelectedIndexChanged);
            this.toolStripComboBox2.SelectedIndexChanged -= 
                new System.EventHandler(this.toolStripComboBox2_SelectedIndexChanged);
            toolStripComboBox2.SelectedIndex = toolStripComboBox2.Items.IndexOf(fontSize.ToString());
            this.toolStripComboBox2.SelectedIndexChanged += 
                new System.EventHandler(this.toolStripComboBox2_SelectedIndexChanged);
        }

        public void SetMainToolBar(bool separatorLine, bool gridLine)
        {
            ʾҳToolStripMenuItem.Checked = separatorLine;
            ʾդToolStripMenuItem.Checked = gridLine;
        }

        private void BASE64ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                openFileDialog1.FileName = "";
                openFileDialog1.Filter = "ıļ|*.txt|ļ|*.*";
                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    System.IO.FileStream tempStream = new System.IO.FileStream(openFileDialog1.FileName,
                        System.IO.FileMode.Open, System.IO.FileAccess.Read);
                    byte[] tempBytes = new byte[tempStream.Length];
                    tempStream.Read(tempBytes, 0, tempBytes.Length);
                    tempStream.Close();
                    ((Grid)this.ActiveMdiChild).reportX.OpenString(System.Text.Encoding.Default.GetString(tempBytes), true);
                }
            }
        }

        private void CSVToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                openFileDialog1.FileName = "";
                openFileDialog1.Filter = "CSVļ|*.csv|ļ|*.*";
                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    System.IO.FileStream tempStream = new System.IO.FileStream(openFileDialog1.FileName,
                        System.IO.FileMode.Open, System.IO.FileAccess.Read);
                    byte[] tempBytes = new byte[tempStream.Length];
                    tempStream.Read(tempBytes, 0, tempBytes.Length);
                    tempStream.Close();
                    ((Grid)this.ActiveMdiChild).reportX.ImportText(1, 1, 
                        System.Text.Encoding.Default.GetString(tempBytes), ",");
                }
            }
        }

        private void TEXTToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                Text text = new Text(false);
                if (text.ShowDialog() == DialogResult.OK)
                {
                    System.IO.FileStream tempStream = new System.IO.FileStream(text.fileName,
                        System.IO.FileMode.Open, System.IO.FileAccess.Read);
                    byte[] tempBytes = new byte[tempStream.Length];
                    tempStream.Read(tempBytes, 0, tempBytes.Length);
                    tempStream.Close();
                    ((Grid)this.ActiveMdiChild).reportX.ImportText(1, 1, 
                        System.Text.Encoding.Default.GetString(tempBytes), text.fileSeparator);
                }
            }
        }

        private void XMLToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                openFileDialog1.FileName = "";
                openFileDialog1.Filter = "XMLļ|*.xml|ļ|*.*";
                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    System.IO.FileStream tempStream = new System.IO.FileStream(openFileDialog1.FileName,
                        System.IO.FileMode.Open, System.IO.FileAccess.Read);
                    byte[] tempBytes = new byte[tempStream.Length];
                    tempStream.Read(tempBytes, 0, tempBytes.Length);
                    tempStream.Close();
                    ((Grid)this.ActiveMdiChild).reportX.ImportXML(System.Text.Encoding.Default.GetString(tempBytes));
                }
            }
        }

        private void BASE64ToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                saveFileDialog1.FileName = "";
                saveFileDialog1.Filter = "ReportXļ|*.rpxe";
                saveFileDialog1.DefaultExt = "rpxe";
                if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    byte[] tempBytes = System.Text.Encoding.Default.GetBytes(
                        ((Grid)this.ActiveMdiChild).reportX.SaveString(true));
                    System.IO.FileStream tempStream = new System.IO.FileStream(saveFileDialog1.FileName,
                        System.IO.FileMode.Create, System.IO.FileAccess.Write);
                    tempStream.Write(tempBytes, 0, tempBytes.Length);
                    tempStream.Close();
                }
            }
        }

        private void CSVToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                saveFileDialog1.FileName = "";
                saveFileDialog1.Filter = "CSVļ|*.csv";
                saveFileDialog1.DefaultExt = "csv";
                if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    byte[] tempBytes = System.Text.Encoding.Default.GetBytes(
                        ((Grid)this.ActiveMdiChild).reportX.ExportText(1, 1, 
                        ((Grid)this.ActiveMdiChild).reportX.ColCount, 
                        ((Grid)this.ActiveMdiChild).reportX.RowCount, ","));
                    System.IO.FileStream tempStream = new System.IO.FileStream(saveFileDialog1.FileName,
                        System.IO.FileMode.Create, System.IO.FileAccess.Write);
                    tempStream.Write(tempBytes, 0, tempBytes.Length);
                    tempStream.Close();
                }
            }
        }

        private void HTMLToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                saveFileDialog1.FileName = "";
                saveFileDialog1.Filter = "HTMLļ|*.html;*.htm";
                saveFileDialog1.DefaultExt = "htm";
                if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    byte[] tempBytes = System.Text.Encoding.Default.GetBytes(
                        ((Grid)this.ActiveMdiChild).reportX.ExportHtml(""));
                    System.IO.FileStream tempStream = new System.IO.FileStream(saveFileDialog1.FileName,
                        System.IO.FileMode.Create, System.IO.FileAccess.Write);
                    tempStream.Write(tempBytes, 0, tempBytes.Length);
                    tempStream.Close();
                }
            }
        }

        private void TEXTToolStripMenuItem1_Click(object sender, EventArgs e)
        {

            if (this.ActiveMdiChild != null)
            {
                Text text = new Text(true);
                if (text.ShowDialog() == DialogResult.OK)
                {
                    byte[] tempBytes = System.Text.Encoding.Default.GetBytes(
                        ((Grid)this.ActiveMdiChild).reportX.ExportText(1, 1,
                        ((Grid)this.ActiveMdiChild).reportX.ColCount,
                        ((Grid)this.ActiveMdiChild).reportX.RowCount, text.fileSeparator));
                    System.IO.FileStream tempStream = new System.IO.FileStream(text.fileName,
                        System.IO.FileMode.Create, System.IO.FileAccess.Write);
                    tempStream.Write(tempBytes, 0, tempBytes.Length);
                    tempStream.Close();
                }
            }
        }

        private void XMLToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild != null)
            {
                saveFileDialog1.FileName = "";
                saveFileDialog1.Filter = "XMLļ|*.xml";
                saveFileDialog1.DefaultExt = "xml";
                if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    byte[] tempBytes = System.Text.Encoding.Default.GetBytes(
                        ((Grid)this.ActiveMdiChild).reportX.ExportXML(0, ""));
                    System.IO.FileStream tempStream = new System.IO.FileStream(saveFileDialog1.FileName,
                        System.IO.FileMode.Create, System.IO.FileAccess.Write);
                    tempStream.Write(tempBytes, 0, tempBytes.Length);
                    tempStream.Close();
                }
            }
        }
    }
}