using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Designer
{
    public partial class Text : Form
    {
        private bool saveOrOpen;
        public string fileName;
        public string fileSeparator;

        public Text(bool SaveOrOpen)
        {
            InitializeComponent();

            saveOrOpen = SaveOrOpen;
            if (SaveOrOpen == true)
            {
                this.Text = "Text";
                button2.Text = "";
            }
            else
            {
                this.Text = "Text";
                button2.Text = "";
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (saveOrOpen == true)
            {
                if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                    textBox1.Text = saveFileDialog1.FileName;
            }
            else
            {
                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                    textBox1.Text = openFileDialog1.FileName;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            fileName = textBox1.Text;
            fileSeparator = "";
            if (radioButton1.Checked == true)
                fileSeparator = ((char)9).ToString();
            else if (radioButton2.Checked == true)
                fileSeparator = ",";
            else if (radioButton3.Checked == true)
                fileSeparator = ";";
            else if (radioButton3.Checked == true)
                fileSeparator = " ";
            else if (radioButton3.Checked == true)
                fileSeparator = textBox2.Text;

            this.DialogResult = DialogResult.OK;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}